
@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

:SETUP
	if "%~1" equ "" goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	!bat_CALL! "!bat_exedir!\ReadParams.bat"
		rem Get the bat_capturedfilesdir value
	call :READCONFIG

	
		rem set bat_detect_dir=%~1

	set bat_detect_dir=%~1
	set bat_targetdrive=!bat_detect_dir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! Invalid path ["!bat_detect_dir!"]
		set bat_returncode=1
		goto :DONE
	)
	
	if /i "!bat_detect_dir:~-4!" equ ".txt" (
		!bat_echolog!
		!bat_echolog! ERROR - Don't specify a detect file, just the path.
		set bat_returncode=1
		goto :DONE
	
	)
	

	set bat_autonomous=
	if /i "%~2" equ "autonomous" (
		set bat_autonomous="autonomous"
	)
	

:DETECTDIR
!bat_log! [!bat_batchfile!:DETECTDIR] [%*]
		

		if not exist "!bat_detect_dir!\backup" (
			!bat_logexeclog! md "!bat_detect_dir!\backup"
		)
	
		if exist "!bat_detect_dir!\ftpdetect*C.txt" (
			!bat_echolog! `  FTPdetectinfo_*C.txt files already exist.  Rather than deleting them, they will be moved to the backup dir.
			!bat_echolog! `  This prevents applying to not completed apply temp files and gets them out of the way.

			if exist "!bat_detect_dir!\ftpdetectinfo_*C.txt" (
				!bat_logexeclog! move /y "!bat_detect_dir!\ftpdetectinfo_*C.txt" "!bat_detect_dir!\backup"
			)

%bat_COMMENT_BEGIN%
	REM It's ok and sometimes we have to apply cals to the merged coincidence files
	
			if exist "!bat_detect_dir!\ftpdetectinfo_CoincC.txt" (
				!bat_logexeclog! move /y "!bat_detect_dir!\ftpdetectinfo_CoincC.txt" "!bat_detect_dir!\backup"
			)
			if exist "!bat_detect_dir!\ftpdetectinfo_CoincM*.txt" (
				!bat_logexeclog! move /y "!bat_detect_dir!\ftpdetectinfo_CoincM*.txt" "!bat_detect_dir!\backup"
			)
			if exist "!bat_detect_dir!\ftpdetectinfo_CoincP*.txt" (
				!bat_logexeclog! move /y "!bat_detect_dir!\ftpdetectinfo_CoincP*.txt" "!bat_detect_dir!\backup"
			)
%bat_COMMENT_END%

		)



		rem Get bat_capturedfilesdir from config file. But we already read it at the start of the program
		
rem		call :READCONFIG

		rem The bat_outputfile is the temp file the appears as a header
		rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
		rem proper Meteor Count = value
	set bat_outputfile=!bat_detect_dir!\meteorcount.txt

		rem This loop doesn't scan the directory, it scans the text of the name and parses it.
		rem CAREFUL - THE DIRECTORY MIGHT BE A COINCIDENCE DIR OR "EmailFiles"...

	for /f "usebackq tokens=*" %%a in ('"!bat_detect_dir!"') do (
		set bat_archdirname=%%~nxa&					rem 2014_12_02_01_31_35
		set bat_dirdate=!bat_archdirname:~0,10!&	rem 2014_12_02
		set bat_captureddate=!bat_dirdate!&			rem 2014_12_02
		set bat_archtime=!bat_archdirname:~-8!&		rem	01_31_35
	)
	
		rem The standard CAMS dirdate is formatted like "YYYY_MM_YY".  The standard Cal file format is
		rem different, like this: "CALCCC_YYYYMMDD_HHHHMMSS_ddd.txt".  So, in order to build a string
		rem to use as a search spec, we need to parse out the components of the date and put them
		rem into the bat_caldate. 
	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!


	!bat_log! bat_detect_dir=!bat_detect_dir!
	!bat_log! bat_targetdrive=!bat_targetdrive!
	!bat_log! bat_outputfile=!bat_outputfile!
	!bat_log! bat_exedir=!bat_exedir!
	!bat_log! bat_dirdate=!bat_dirdate!
	!bat_log! bat_currdate=!bat_currdate!
	
		rem Caution: The bat_capturedfilesdir variable may not be defined yet because we're essentially relying 
		rem          at this point on READCONFIG, but it's not reliable source.
	!bat_log! bat_capturedfilesdir=!bat_capturedfilesdir!
	!bat_log! bat_camera=!bat_camera!

	set bat_cameralist_file=!bat_detect_dir!\SortDetect_CameraList.txt

	if /i "!bat_detect_dir!" equ "" (
		!bat_popecho!
		!bat_echolog! The bat_detect_dir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		!bat_echolog! Right now, it is set to [bat_detect_dir="%bat_detect_dir%"].
		!bat_echolog!
		
		if not defined bat_autonomous (

			!bat_prompt! Manually enter the bat_detect_dir value now or [Q]uit: 
			bat_detect_dir=!bat_choice!
		) else (
			set bat_returncode=1
			!bat_echolog! `    set bat_returncode=!bat_returncode!
			goto :DONE
		)
		
		if /i "!bat_detect_dir!" equ "q" goto :DONE

		goto :DETECTDIR
	)
goto :MAIN %*




:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	set bat_returncode=0

	call :GETDETECTFILE
	!bat_log! bat_returncode=[!bat_returncode!]

	
	!bat_logexeclog! set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

	!bat_CALL! "!bat_exedir!\GetCameraList.bat" "!bat_capturedfilesdir!"
	set bat_returncode=0

	
	if /i "!bat_returncode!" equ "0" (
		call :APPLYBEGIN "!bat_detectfile!"
	)

:MAIN_END
!bat_poplog! [END-!bat_batchfile!:MAIN] - goto :DONE
goto :DONE



	rem *************************************************************
	rem ***** This should be made into a standalone batch file ******
	rem
	rem Remember, the FTP_ApplyCal2Detectinfo.exe program is passed a
	rem valid detect file.  The program then gets its CAL dir from
	rem the 6th line in that file.
	rem 
	rem *************************************************************
	
:APPLYBEGIN
!bat_pushlog! [CALL !bat_batchfile!:APPLYBEGIN] %*

	set bat_detect_dir=%~dp1::
	set bat_detect_dir=!bat_detect_dir:\::=!
	set bat_detect_dir=!bat_detect_dir:::=!


:APPLY1
!bat_log! [!bat_batchfile!:APPLY1]

	set bat_returncode=0

	!bat_echolog!
	!bat_echolog!     This step runs FTP_ApplyCal2Detectinfo.exe
	!bat_echolog!

	if not defined bat_autonomous (
	
			REM Display the list of cal entries.
			REM 
			REM Pay close attention to the *** MATCH *** AND
			REM *** MISMATCH ***
			rem 
			
		call :LIST_DETECT_CAL_ENTRIES

		!bat_prompt! Use this and [A]pply the cal, [S]kip, or [Q]uit : 
		
		if /i "!bat_choice!" equ "q" (
			set bat_returncode=9
			!bat_log! `    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
		
			rem We need to document better this SKIP option.  I can't remember what it's supposed to
			rem accomplish.  It appears that it's just skipping the APPLY phase and fetching the
			rem bat_calname used in the detect. It may no longer be a valid method. 
			
		if /i "!bat_choice!" equ "s" (
			!bat_log! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_detectfile1!"`^) do...
			for           /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfile1!"`) do (
				set bat_temp=%%a
				if "!bat_temp:~3,3!" equ "!bat_camera!" (
					set bat_calname=%%a
				)
			)

			goto :APPLY4
		)

		if /i "!bat_choice!" NEQ "a" (goto :APPLY1)
	)

	find /i ".bin" "!bat_detectfile1!">nul:
	if !errorlevel! neq 0 (
		!bat_echolog! `    !bat_batchfile!:APPLYBEGIN - ERROR 20 - No events found in "!bat_detectfile1!"
		set bat_returncode=20
		!bat_log! `    set bat_returncode=!bat_returncode!
		goto :APPLY5
	)

	!bat_echolog! *************************************************************
	!bat_echolog! `        call "!bat_exedir!\FTP_ApplyCal2Detectinfo.exe" "!bat_detectfile1!"{CRLF.inp
	                 !bat_CALL! "!bat_exedir!\FTP_ApplyCal2Detectinfo.exe" "!bat_detectfile1!"<CRLF.inp
	set bat_returncode=!errorlevel!
	!bat_echolog! Back from  call "!bat_exedir!\FTP_ApplyCal2Detectinfo.exe" "!bat_detectfile1!"
	!bat_echolog! [bat_returncode=!bat_returncode!]
	!bat_echolog! *************************************************************
	
	if "!bat_returncode!" neq "0" (
		!bat_echolog!
		!bat_echolog! `    !bat_batchfile!:APPLYBEGIN - ERROR !bat_returncode! - Aborting - Program returned with the error code
		!bat_echolog!
		goto :APPLY5
	)
	

	!bat_echolog!
	!bat_pushecho! Now checking validity of the outcome...

		rem We check the validity by:
		rem   1. Fetch the first FF file in the detect file
		rem   2. Fetch the first Cal file in the detect file
		

		rem ====================================================
		rem ====            CALL GETAPPLYCALSTATUS         =====
		REM 
		REM Reports on which cameras in the detect file still need
		rem calibration/apply steps.
		rem 


	!bat_CALL! "!bat_exedir!\GetApplyCalStatus.bat" "!bat_capturedfilesdir!" "!bat_detect_dir!\!bat_detectfile3!C.txt"
	set bat_returncode=!errorlevel!


		rem ===========================================================
		rem ====            CALL GetFirstLastFF_filenames        =====
		REM 
		REM Fetches the bat_FFfirst and bat_FFlast FF file names from the
		REM CapturedFiles dir.
		rem 
		
	if not defined bat_FFfirst (
		!bat_CALL! "!bat_exedir!\GetFirstLastFF_filenames.bat" "bat_FFfirst"    "bat_FFlast"   "!bat_capturedfilesdir!"
rem		!bat_logexeclog! call "!bat_exedir!\GetFirstLastFF_filenames.bat" "bat_FFfirst"    "bat_FFlast"   "!bat_capturedfilesdir!"
	)


	!bat_pop!

	
	!bat_echolog!
	if not defined bat_autonomous (

:APPLYCONFIRMMOVE
		!bat_prompt! If this is correct, enter [A]pply, [R]eject and try again, or [Q]uit : 
		if /i "!bat_choice!" equ "a" goto :APPLYMOVE
		if /i "!bat_choice!" equ "r" (
			DEL /q "!bat_detect_dir!\!bat_detectfile3!C.txt"
			goto :APPLYBEGIN
		)
		if /i "!bat_choice!" equ "q" (
			set bat_returncode=9
			DEL /q "!bat_detect_dir!\!bat_detectfile3!C.txt"
			!bat_log! `    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
		goto :APPLYCONFIRMMOVE
	) else (
		goto :APPLYMOVE
	)

:APPLYMOVE	
!bat_log! [!bat_batchfile!:APPLYMOVE]

	!bat_echolog!
	!bat_logexec! MOVE /y "!bat_detect_dir!\!bat_detectfile3!C.txt" "!bat_detectfile1!"
	!bat_echolog!

:APPLY4
!bat_log! [!bat_batchfile!:APPLY4]
	if exist "!bat_detect_dir!\!bat_detectfile3!C.txt" (
		set bat_returncode=1
		!bat_echolog! `     !bat_batchfile!:APPLYEND - ERROR - The {apply} file wasn't able to be moved to the detect file
		!bat_echolog! `                                "!bat_detect_dir!\!bat_detectfile3!C.txt"
		
		if defined bat_autonomous (
			goto :APPLY5
		) else (
			set bat_choice=
			!bat_prompt!  [C]ontinue, [R]etry, or [Q]uit?  
			if /i "!bat_choice!" equ "c" goto :APPLY5
			
			if /i "!bat_choice!" equ "q" (
				set bat_returncode=9
				del /q "!bat_detect_dir!\!bat_detectfile3!C.txt"
				!bat_log! `    set bat_returncode=!bat_returncode!
				goto :APPLY5
			)
			
			if /i "!bat_choice!" equ "r" (
				del /q "!bat_detect_dir!\!bat_detectfile3!C.txt"
				goto :APPLYBEGIN
			)
			
			goto :APPLY4
		)
	) else (
		!bat_echolog! `    Move was successful and there is only one detect file. Now checking if the cal file is in the detect file...

%bat_COMMENT_BEGIN%
		find /i /c "!bat_calname!" "!bat_detectfile1!">nul:
		if "!errorlevel!" equ "0" (
			!bat_echolog!
			!bat_echolog!   !bat_batchfile! - SUCCESS - '!bat_calname!' was applied to '!bat_detectfile1!'
			!bat_echolog!
			set bat_returncode=0
			!bat_log! `    set bat_returncode=!bat_returncode!
		) else (
			!bat_echolog!
			!bat_echolog!   !bat_batchfile!:APPLY4 - ERROR - '!bat_calname!' was NOT applied to '!bat_detectfile1!'
			!bat_echolog!
			set bat_returncode=25
			!bat_log! `    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)

%bat_COMMENT_END%

	)

:APPLY5
!bat_poplog! [RETURN !bat_batchfile!:APPLYBEGIN] [bat_returncocde=!bat_returncode!]
!bat_log!
!bat_return!





:LIST_DETECT_CAL_ENTRIES

%bat_COMMENT_BEGIN%	
		!bat_echolog! You may be given the following instruction due to a confusing typo in the .exe program:
		!bat_echolog! Navigate to FTP Detection File to Process for Coincidence'.  
		!bat_echolog!
		!bat_echolog! It means to:
		!bat_echolog!
		!bat_echolog! `   Navigate to the FTP Detection file to Process for Apply".
		!bat_echolog!
		!bat_echolog! Instead, navigate to and select: "!bat_detectfile1!".
%bat_COMMENT_END%

		if /i exist "!bat_detectfile1!" (
			!bat_echolog!
			!bat_echolog! Note: The current CAL files found in the detect file [!bat_detectfile1!]
			!bat_echolog! `     that should match the Cal Date:
			!bat_pushecho! `       "!bat_caldate!" are:
				!bat_echolog!
				set /a bat_count_match=0
				set /a bat_count=0
				set /a bat_count_mismatch=0
				for /f "usebackq tokens=*" %%a in (`type "!bat_detect_dir!\CalFileList.log"`) do (
					set /a bat_count+=1
					
					set bat_cal_temp=%%a
					set bat_cal_temp_dirdate=!bat_cal_temp:~7,8!
					
					if /i "!bat_cal_temp_dirdate!" equ "!bat_caldate!" (
						set /a bat_count_match+=1
						!bat_echolog! %%a		MATCH
					) else (
						set /a bat_count_mismatch+=1
						!bat_echolog! %%a		**** MISMATCH - Needs Apply ****
					)
				)
			!bat_popecho!
		)

:LIST_DETECT_CAL_ENTRIES_END
!bat_return!




:GETDETECTFILE
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*

	set bat_returncode=0
	set bat_detectfile_temp=

	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" "bat_detectfile" "!bat_detect_dir!"
	
	set bat_returncode=!errorlevel!
	if "!bat_returncode!" neq "0" (
			!bat_echolog! `     ERROR - GetDetectFile.bat - Returned error code "!bat_returncode!"
			!bat_echolog! `             bat_detectfile="!bat_detectfile!"
		goto :GETDETECTFILE_END
	)

	if not exist "!bat_detectfile!" (
			set bat_returncode=2
			!bat_echolog! `     Not found: "!bat_detect_dir!\FTPdetectinfo_0*.txt"
			goto :GETDETECTFILE_END
	)

		rem Parse the bat_detectfile full name into parts...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_detectfile!" /a-d /b /od`) do (
		set bat_detectfile_temp=!bat_detect_dir!\%%~nxa
		set bat_detectfile1=!bat_detect_dir!\%%~nxa
		set bat_detectfile2=%%~nxa
		set bat_detectfile3=%%~na
	)

	if not defined bat_detectfile_temp (
		set bat_returncode=2
		!bat_echolog! `     Not found: "!bat_detect_dir!\FTPdetectinfo_0*.txt"
		goto :GETDETECTFILE_END
	)


:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_returncode=!bat_returncode!, 
!bat_log! `                                        bat_camera=!bat_camera!, 
!bat_log! `                                        bat_camera_list=!bat_camera_list!, 
!bat_log! `                                        bat_detectfile=!bat_detectfile!]
!bat_log!
!bat_return!




	rem Checks to see if the camera in arg1 exists in the GCFC.log file
	rem Returns: bat_GCFC_found=true if the camera is found
:CHECK_GCFC
rem !bat_pushlog! [CALL !bat_batchfile!:CHECK_GCFC] [%*]
	set bat_GCFC_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_GCFC_tempfile!"`) do (
		if /i "%~1" equ "%%~x" (
			set bat_GCFC_found=true
		)
	)
:CHECK_GCFC_END
rem !bat_poplog! [RETURN !bat_batchfile!:CHECK_GCFC] [%~1, bat_GCFC_found=!bat_GCFC_found!]
!bat_return!




:GETCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERALIST] %*

	set bat_camera_list=
	for /f "usebackq tokens=*" %%a in (`type "!bat_GCFC_tempfile!"`) do (
		if not defined bat_camera_list (
			set bat_camera_list=0!%%a
		) else (
			set bat_camera_list=!bat_camera_list!0%%a
		)
	)

:GETCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERALIST] [bat_cameralist=!bat_cameralist!]
!bat_log!
!bat_return!






	rem *************************************************************
	rem ****               CHECK_APPLY_C                         ****
	rem 
	rem Scans and lists the last the FF files and its cal file for
	rem each camera.
	rem 
	rem Parameters:
	rem     %~1					The detectfileC to scan
	rem 
	rem *************************************************************

:CHECK_APPLY_C
!bat_pushlog! [CALL !bat_batchfile!:CHECK_APPLY_C] [%*]

	set bat_returncode=0

	!bat_pushlog! for /f "usebackq tokens=*" ..c in ^(`type "!bat_cameralist_file!"`^) do ^(
	              for /f "usebackq tokens=*" %%c in  (`type "!bat_cameralist_file!"`) do (

			rem For each camera...	
		set bat_ffname=
		set bat_calname=
		set bat_camera_temp=
		!bat_pushlog! for /f "usebackq tokens=* skip=2" ..a in ^(`findstr /i  /c:"CAL%%c_" "!bat_detect_dir!\!bat_detectfile3!C.txt"`^) do...
		for               /f "usebackq tokens=* skip=2" %%a in  (`findstr /i  /c:"CAL%%c_" "!bat_detect_dir!\!bat_detectfile3!C.txt"`) do (
			set bat_temp=%%a

%bat_COMMENT_BEGIN%

			if /i "!bat_temp:~0,6!" equ "FF%%c_" (
				if not defined bat_ffname (
					set bat_camera_temp=!bat_temp:~2,3!
					set bat_ffname=!bat_temp!
					
					if /i "!bat_ffname:~6,8!" equ "!bat_caldate!" (
						set bat_match_string=	**** MATCH ****
					) else (
						set bat_match_string=	**** MISMATCH ****
						set bat_returncode=21
					)
					!bat_echolog! `  !bat_ffname!	[The first FF file for camera !bat_camera_temp! in the detect file after applying]
					
				)
			)
%bat_COMMENT_END%
			
			if /i "!bat_temp:~0,7!" equ "CAL%%c_" (
				if not defined bat_calname (
					set bat_calname=!bat_temp!

					if /i "!bat_calname:~7,8!" equ "!bat_caldate!" (
						set bat_match_string=	**** MATCH ****
					) else (
						set bat_match_string=	**** MISMATCH Needs manual cal ****
						set bat_returncode=22
					)
					!bat_echolog! ` !bat_temp!		[The first CAL file for camera !bat_camera_temp! in the detect file after applying] !bat_match_string!
				)
			)
		)
		!bat_poplog! ^) // bat_camera=[%%c], bat_ffname=[!bat_ffname!]
		!bat_echolog!


%bat_COMMENT_BEGIN%
		if defined bat_ffname (
			rem !bat_echolog! !bat_ffname!       [The first FF file in the detect file after applying]
		) else (
			!bat_echolog! `    ERROR 23 - Could not find ".bin" files in "!bat_detect_dir!\!bat_detectfile3!C.txt"
			!bat_echolog! `            Check the camera number.
			!bat_echolog!
			set bat_returncode=23
			!bat_log! `    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
%bat_COMMENT_END%


		if defined bat_calname (
			rem !bat_echolog! !bat_calname!      [The current CAL file in the detect file after applying]
		) else (
			!bat_echolog! `    ERROR 24 - Could not find ".txt" files in "!bat_detect_dir!\!bat_detectfile3!C.txt"
			!bat_echolog! `              Check the camera number
			set bat_returncode=24
			!bat_log! `    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)


		!bat_echolog!

		if not defined bat_camera_temp (
			!bat_echolog! `    WARNING - no camera number defined
			!bat_logexec! set bat_camera_temp=!bat_ffname:~2,3!
		)


	)
	!bat_poplog! ^) // bat_ffname=[!bat_ffname!]

	
:CHECK_APPLY_C_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_APPLY_C] []
!bat_log!
!bat_return!










:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*

	!bat_CALL! "!bat_exedir!\ReadConfig.bat"

%bat_COMMENT_BEGIN%
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_CALL! "!bat_exedir!\Readini.bat" "!bat_configfile!" "CAMSMENU" bat_capturedfilesdir /q
	if !bat_logexec_returncode! equ 0 (
		set bat_capturedfilesdir=!RetVal1!
	)
%bat_COMMENT_END%

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [bat_capturedfilesdir=!bat_capturedfilesdir!]
!bat_log!
!bat_return!










:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo    The bat_capturedfilesdir is obtained by reading that setting
	echo    from the Autocams.bat.ini file. 
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1^) Run FTP_ApplyCal2Detectinfo 
	echo       2^) Test the resulting FTPdetectinfoC.txt for proper cal
	echo       3^) Move/rename the resulting FTPdetectinfoC.txt
	echo       4^) Test the resulting FTPdetectinfo.txt for proper cal
exit /b



:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! exit /b !bat_returncode!
	              exit /b !bat_returncode!
