@echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

	echo.[!date! !time!] [%~nx0] Waiting 10 seconds to unlock the log files...
	TIMEOUT /nobreak 10

goto :SETUP

	Flow chart:
	
	Returns:
	
	
:SETUP



	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"
	set bat_pushstring=

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
	!bat_logexeclog! set bat_

	set bat_CD_flag=%~1
	set bat_CAPTURE.cameralist=%~2
	set bat_duration=%~3
	set bat_targetlocation=%~4
	set bat_savetargetlocation=%~4

	if defined bat_CAPTURE.archive_flag (
		set bat_CD_flag=!bat_CAPTURE.archive_flag!
	)

	set bat_autonomous=
	if /i "%~5" equ "autonomous" (
		set bat_autonomous=autonomous
	)
	if /i "%~5" equ "auto" (
		set bat_autonomous=autonomous
	)
	
	set bat_testmode=
    echo.%*|find /i "/testmode">nul:
    if %errorlevel% equ 0 (
    	set bat_testmode=testmode
    )

rem	!bat_logexeclog! type "!bat_paramsfile!"
rem	!bat_logexeclog! type "!bat_configfile!"
	
	!bat_logexeclog! set bat_autocams.abort=false

	!bat_logexeclog! set bat_

    call :SETCAPTUREEXE

goto :MAIN %*



:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*

	rem call :CURDATETIME %*
	call :PRECAPTURE %*

	call :LAUNCHCAPTURE %*
	if "!bat_returncode!" neq "0" (
		!bat_echolog! `    Error during capture - aborting remaining steps
		goto :MAIN_END
	)

	set bat_runautocams=
	
	call :GETCAPTUREDIR %*
	if "!bat_retval!" equ "failed" (
		goto :MAIN_END
	)
	
	!bat_echolog! Create the GCFC.log file
	!bat_CALL! "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
	!bat_echolog!
		

	call :LOGSKIPPEDFRAMES

	if /i "!bat_CAPTURE.archive_flag!" equ "-1" (
		!bat_echolog! `Note: When bat_CAPTURE.archived_flag is -1, it 
		!bat_echolog! `      means to do capture without detect.
		!bat_echolog! `      Therefore, we need to do detection now...

		call :REPROCESSMULTI
		call :GETARCHIVEDDIR %*
		call :WAITFORMULTISCAN %*

		!bat_logexec! move /y "!bat_archiveddir!" "!bat_targetlocation!\CAMS\ArchivedFiles\!bat_captureddatetime!"

		call :GETARCHIVEDDIR %*
		call :WAITFORMULTISCAN %*
		call :MERGECASE %*
	) else (
			rem Detection was part of capture
		call :GETARCHIVEDDIR %*
		call :WAITFORMULTISCAN %*
	)

	rem Since GetDetectFile.bat uses the variables from autocams.bat.ini, we need to save 
	rem whatever variable's values that we have changed before calling GetDetectFile.bat
	!bat_CALL! "!bat_exedir!\SaveConfig.bat"


	set bat_runautocams=!bat_retval!
	call :GETDETECTFILE %*
	call :WAITFORMULTISCAN %*
	call :COPYARCHIVED %*

	call :POSTCAPTURE %*
	if /i "!bat_retval!" neq "postcapture success" (
		goto :DONE
	)
	
		rem You get to here if there NO PROBLEMS...

	call :VARIABLES_LOG bat_log
	
	!bat_pop!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! DONE: with -------- %~0 %* ----------------------
	!bat_echolog! [END !bat_batchfile!:MAIN]
	!bat_echolog!
	!bat_pop!
	!bat_echolog! "!bat_exedir!\AutoCams.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! !bat_autonomous!
	!bat_echolog! END OF %~nx0  ******  %date% %time%
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
	!bat_echolog!

	if "!bat_autocams.abort!" neq "true" (
	   "!bat_exedir!\AutoCams.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! !bat_autonomous!
	)

:MAIN_END
!bat_poplog! [END !bat_batchfile!:MAIN]
!bat_echolog! !bat_WAIT!  !bat_AUTOCAMS.completewait!
!bat_WAIT!  !bat_AUTOCAMS.completewait!
goto :DONE





:PRECAPTURE
!bat_pushlog! [CALL !bat_batchfile!:PRECAPTURE] %*
	rem [in]	
	rem [out]	bat_precaptureddir
	rem [out]	bat_precaptureddirarch

		rem SIMULATION - Only do this if the [CAPTURE] simulation is set - 
		rem Essentially, clean up the directories to the pre-capture state. 
	if /i "!bat_SIMULATION.enabled!" equ "true" (
		!bat_pushecho! Simulating Capture and Detect by removing the test dirs...
			if defined bat_SIMULATION.CapturedFilesDir (
				!bat_logexec! del /q "!bat_SIMULATION.CapturedFilesDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.CapturedFilesDir!"
				!bat_logexec! del /q "!bat_SIMULATION.ArchivedFilesDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.ArchivedFilesDir!"
				!bat_logexec! del /q "!bat_SIMULATION.SubmittedDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.SubmittedDir!"
				!bat_logexec! del /q "!bat_SIMULATION.SubmittedDir!\!bat_captureddir!_*.zip"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:PRECAPTURE] Dangerous command: del /q "!bat_SIMULATION.CapturedFilesDir!"
			)

			if defined bat_SIMULATION.SubmissionFilesDir  (
				!bat_logexec! del /q /s "!bat_SIMULATION.SubmissionFilesDir!"
				!bat_logexec! rd /q /s "!bat_SIMULATION.SubmissionFilesDir!"
			) else (
				!bat_echolog! ERROR [!bat_batchfile!:PRECAPTURE] Dangerous command: del /q /s "!bat_SIMULATION.SubmissionFilesDir!"
				!bat_pause!
				exit /b -98
			)

		!bat_popecho!
rem		set /p bat_choice=Check the ArchivedFiles and CapturedFiles dirs... 
	)& rem SIMULATION

	!bat_log! Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	!bat_log! ordered ascending by date. The last one will be the one BEFORE the next one
	!bat_log! created by the FTP_CaptureXxx executable (for comparison later).

	!bat_logexeclog! set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	!bat_logexeclog! set bat_precaptureddir=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_precaptureddir=!bat_targetsearchspec!\%%~a
				)
			)
		)
	)
		!bat_logexeclog! set bat_precaptureddir
	!bat_poplog!

	if not defined bat_precaptureddir (set bat_precaptureddir= )

	!bat_log! Iterate through the list of !bat_targetlocation!\CAMS\ArchivedFiles directories, 
	!bat_log! ordered ascending by date. The last one will be the one BEFORE the next one
	!bat_log! created by the FTP_CaptureXxxDetect... executable (for comparison later).

	!bat_logexeclog! set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
	!bat_logexeclog! set bat_precaptureddirarch=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_precaptureddirarch=!bat_targetsearchspec!\%%~a
				)
			)
		)
	)
		!bat_logexeclog! set bat_precaptureddirarch
	!bat_poplog!

		rem purposefully change it to space so that it is defined, but not the same as anything new that could be created. 
	if not defined bat_precaptureddirarch (set bat_precaptureddirarch= )
		

:PRECAPTURE_END
!bat_poplog! [RETURN !bat_batchfile!:PRECAPTURE] [bat_precaptureddir="!bat_precaptureddir!", 
!bat_log! `                                            bat_precaptureddirarch="!bat_precaptureddirarch!"] 
!bat_log! `                                            %*
!bat_log!
!bat_return!






:LAUNCHCAPTURE
!bat_pushlog! [CALL !bat_batchfile!:LAUNCHCAPTURE] %*
	rem [in]	
	rem [out]	bat_returncode
	rem [out]	bat_entervideodevice
	rem [uses]	bat_CAPTURE.capture_mode
	
	set bat_returncode=-1
	!bat_echolog! bat_returncode=!bat_returncode!

	if /i "!bat_CAPTURE.capture_mode!" equ "capturetwoanddetect" (
		CALL :LAUNCH_DUAL_CAPTURE %*
		goto :LAUNCHCAPTURE2
	) else (
		!bat_log! ELSE  "!bat_CAPTURE.capture_mode!" NEQ "capturetwoanddetect"
	)

	!bat_echolog!
	!bat_echolog! [!date! !time!] Killing any existing !bat_captureexe! processes that might be running...
	!bat_logexeclog! call process -k !bat_captureexe!

		rem Copies the EXE file to a name that matches the instance 
	if /i "!bat_CAPTURE.capture_mode!" NEQ "capturetwoanddetect" (
		rem copy "!bat_captureexesrc!" "!bat_captureexe!"
		call :COPYEXE
	)

	!bat_echolog!
	!bat_echolog! Starting !bat_captureexe!...
	!bat_push!
		if /i "!bat_captureexesrc!" equ "FTP_Capture.exe" (
				rem The FTP_Capture.exe program is outdated and it doesn't have the bat_CD_flag option, so we have a special treatmen for it just in case someone HAS TO use it.
			!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
			!bat_echolog!          "!bat_captureexe! start" !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!
			title "[!date! !time!] "!bat_captureexe! start" !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!

			!bat_logexeclog! set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!

		)
		
		if /i "!bat_captureexesrc!" equ "FTP_CaptureAndDetect.exe" (
			!bat_echolog!          "!bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!
			title "[!date! !time!] "!bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!

			!bat_logexeclog! set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!
		)

	!bat_pop!

		rem Determine if an input file is needed to answer the input question in case
		rem there are multiple video inputs
	set bat_entervideodevice=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\entervideodevice*.inp" /a-d /b`) do (
		set bat_entervideodevice=%%a
	)

		rem SIMULATION - Only do this if the [CAPTURE] simulation is set
	if /i "!bat_SIMULATION.capture!" equ "true" (
		!bat_echolog!
		!bat_pushecho! Simulating capture by copying directories...
			!bat_logexec! md "!bat_SIMULATION.CapturedFilesDir!"

			!bat_push!
				rem !bat_logexec! copy /y "!bat_SIMULATION.CapturedFilesSimSource!" "!bat_SIMULATION.CapturedFilesDir!"
				for /f "usebackq tokens=*" %%a in (`dir "!bat_SIMULATION.CapturedFilesSimSource!" /s/b /a-d`) do (
					set bat_temp=%%~nxa
					if /i "!bat_temp:~-5!" neq ".binx" (
						!bat_echo! "!bat_SIMULATION.CapturedFilesDir!\%%~nxa"
						copy /y "%%a" "!bat_SIMULATION.CapturedFilesDir!">nul:
					)
				)
				!bat_logexeclog! dir "!bat_SIMULATION.CapturedFilesDir!" /s/b
			!bat_pop!
			!bat_log!

			if /i "!bat_CAPTURE.archive_flag!" neq "-1" (
					rem Capture WITH detection...
				!bat_log!
				!bat_pushecho!    copy /y "!bat_SIMULATION.ArchivedFilesSimSource!" "!bat_SIMULATION.ArchivedFilesDir!"
					for /f "usebackq tokens=*" %%a in (`dir "!bat_SIMULATION.ArchivedFilesSimSource!" /s/b /a-d`) do (
						!bat_echo! "!bat_SIMULATION.ArchivedFilesDir!\%%~nxa"
						copy /y "%%a" "!bat_SIMULATION.ArchivedFilesDir!">nul:
					)
					!bat_logexeclog! dir "!bat_SIMULATION.ArchivedFilesDir!" /s/b
				!bat_popecho!
				

				!bat_pushecho! Simulating Capture WITH Detect...
					!bat_logexeclog! md "!bat_SIMULATION.ArchivedFilesDir!"

					!bat_pushecho! copy /y "!bat_SIMULATION.ArchivedFilesSimSource!" "!bat_SIMULATION.ArchivedFilesDir!"
						for /f "usebackq tokens=*" %%a in (`dir "!bat_SIMULATION.ArchivedFilesSimSource!" /s/b /a-d`) do (
							!bat_echo! "!bat_SIMULATION.ArchivedFilesDir!\%%~nxa"
							copy /y "%%a" "!bat_SIMULATION.ArchivedFilesDir!">nul:
						)
						!bat_logexeclog! dir "!bat_SIMULATION.ArchivedFilesDir!"
					!bat_popecho!

					!bat_logexec! dir "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak"
					!bat_logexec! move /y "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak"  "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!"
				!bat_popecho!
			) else (
				!bat_echolog!
				!bat_pushecho! Simulating Capture WITHOUT Detect...
					!bat_logexeclog! md  "!bat_SIMULATION.ArchivedFilesDir!"
					!bat_logexeclog! dir "!bat_SIMULATION.ArchivedFilesDir!"

				!bat_pop!
			)
		
		!bat_pop!
		!bat_echolog! bat_returncode=!bat_returncode!
		set bat_returncode=0
		!bat_echolog! bat_returncode=!bat_returncode!
		goto :LAUNCHCAPTURE2
	)& rem if /i "!bat_SIMULATION.capture!" equ "true" 

	rem *************** NOT SIMULATING CAPTURE ******************
	if not defined bat_entervideodevice (
			rem NON-SIMULATION
		if /i "!bat_SIMULATION.capture!" neq "true" (
			rem RUN THE CAPTURE COMMAND			
			
	!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
	!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
	!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
	!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
			!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
			!bat_echolog! !bat_launchcommand!
			
			
			
			!bat_launchcommand!
			set bat_returncode=!errorlevel!
			
			
			
	!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
	!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
	!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
	!bat_echolog! bat_logfile_full="!bat_logfile_full!" 

		)
	) else (
			rem NON-SIMULATION
		if /i "!bat_SIMULATION.capture!" neq "true" (
			rem RUN THE CAPTURE COMMAND
			!bat_echolog! ________________________________________________________________________
			!bat_echolog! ________________________________________________________________________
			!bat_echolog! ________________________________________________________________________
			!bat_echolog! [!date! !time!] !bat_launchcommand!
			!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
			!bat_echolog! !bat_launchcommand!{"!bat_exedir!\!bat_entervideodevice!"
			
			
			
			!bat_launchcommand!<"!bat_exedir!\!bat_entervideodevice!"
			set bat_returncode=!errorlevel!
	
	
			!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
			!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
			!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
			!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
			
			
	    )
	)& rem if not defined bat_entervideodevice

	!bat_echolog! errorlevel=!bat_returncode!
	
	if /i "!bat_returncode!" neq "0" (
		!bat_CALLecho! "!bat_exedir!\ProcessCaptureReturnCode.bat"
		!bat_echolog! `    ERROR - !bat_recent_error_msg!
	) else (
		!bat_echolog! `    OK - Capture executed OK.
	)
goto :LAUNCHCAPTURE2

:LAUNCHCAPTURE2
!bat_echolog! [GOTO !bat_batchfile!:LAUNCHCAPTURE2]
	!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
	!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
	!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
	!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
	!bat_echolog! [!date! !time!] END !bat_launchcommand!
	!bat_echolog! [bat_returncode=!bat_returncode!]

:LAUNCHCAPTURE_END
!bat_poplog! [RETURN !bat_batchfile!:LAUNCHCAPTURE] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!



:LAUNCH_DUAL_CAPTURE
!bat_pushecho! [CALL !bat_batchfile!:LAUNCH_DUAL_CAPTURE] [%*]

	rem [in]	
	rem [out]	bat_returncode
	rem [out]	bat_entervideodevice
	rem [uses]	bat_CAPTURE.capture_mode

		rem the bat_captureexe setting will indicate
	!bat_echolog!
	!bat_echolog! Killing any existing FTP_CaptureTwoAndDetect.exe processes that might be running...
	!bat_logexeclog! call process -k !bat_captureexe!


	!bat_echolog!
	!bat_echolog! Starting !bat_captureexe!...
	!bat_echolog! `        "!bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!
    title "[%date% %time%]  !bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!

	!bat_logexeclog! set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_CAPTURE.sunangle_dusk! !bat_targetlocation!

		rem Determine if an input file is needed to answer the input question in case
		rem there are multiple video inputs
	set bat_entervideodevice=
	if exist "!bat_exedir!\entervideodevice*.inp" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\entervideodevice*.inp" /a-d /b`) do (
			set bat_entervideodevice=%%a
			!bat_echolog! Using entervideodevice [bat_entervideodevice=!bat_entervideodevice!]
		)
	)


	if not defined bat_entervideodevice (
		!bat_pushecho! Not using: [entervideodevice*.inp]
						    
			if defined bat_CAPTURE.delete.during.capture (

				!bat_echolog! process -k "cmd_delete_during_capture.bat.exe"
							  process -k "cmd_delete_during_capture.bat.exe"

				rem copying a cmd.exe to the local directory and renaming it so that it's a trackable batch file
				!bat_echolog! copy /y "!windir!\system32\cmd.exe" "!bat_exedir!\cmd_delete_during_capture.bat.exe"
							  copy /y "!windir!\system32\cmd.exe" "!bat_exedir!\cmd_delete_during_capture.bat.exe"

				!bat_echolog! start "DELETE.DURING.CAPTURE" /low /min  "!bat_exedir!\cmd_delete_during_capture.bat.exe" /c ""!bat_exedir!\delete_during_capture.bat" "!bat_precaptureddir!" "!bat_CAPTURE.delete.during.capture!""
							  start "DELETE.DURING.CAPTURE" /low /min  "!bat_exedir!\cmd_delete_during_capture.bat.exe" /c ""!bat_exedir!\delete_during_capture.bat" "!bat_precaptureddir!" "!bat_CAPTURE.delete.during.capture!""
				!bat_WAIT!  10
			)


			if /i "!bat_SIMULATION.capture!" neq "true" (
					rem simulation
					rem Only do this if the [CAPTURE] simulation is NOT set
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
				!bat_echolog! [!date! !time!] !bat_launchcommand!

				!bat_launchcommand!
				set bat_returncode=!errorlevel!

				!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
				!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
				!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
				!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
				!bat_echolog! [!date! !time!] END: !bat_launchcommand!
				!bat_echolog! [bat_returncode=!bat_returncode!]

			) else (
					rem SIMULATION - Only do this if the [CAPTURE] simulation is set
				!bat_echolog!
				!bat_pushecho! Simulating capture...
					!bat_echolog!

					!bat_logexeclog! md "!bat_SIMULATION.CapturedFilesDir!"
					!bat_logexeclog! md "!bat_SIMULATION.ArchivedFilesDir!"

					!bat_pushecho! copy /y "!bat_SIMULATION.CapturedFilesSimSource!" "!bat_SIMULATION.CapturedFilesDir!"
						for /f "usebackq tokens=*" %%a in (`dir "!bat_SIMULATION.CapturedFilesSimSource!" /s/b /a-d`) do (
							set bat_temp=%%~nxa
							if /i "!bat_temp:~-5!" neq ".binx" (
								!bat_echo! "!bat_SIMULATION.CapturedFilesDir!\%%~nxa" ....
								copy /y "%%a" "!bat_SIMULATION.CapturedFilesDir!">nul:
							)
						)
						!bat_logexeclog! dir "!bat_SIMULATION.CapturedFilesDir!" /s/b /a-d
					!bat_popecho!
				!bat_popecho!

				!bat_pushecho! Simulating detect...
					!bat_pushecho!    copy /y "!bat_SIMULATION.ArchivedFilesSimSource!" "!bat_SIMULATION.ArchivedFilesDir!"
						for /f "usebackq tokens=*" %%a in (`dir "!bat_SIMULATION.ArchivedFilesSimSource!" /s/b /a-d`) do (
							!bat_echo!       "!bat_SIMULATION.ArchivedFilesDir!\%%~nxa"
							copy /y       "%%a" "!bat_SIMULATION.ArchivedFilesDir!">nul
						)
					!bat_popecho!

					if /i "!bat_CAPTURE.archive_flag!" neq "-1" (
						!bat_logexeclog! dir "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak"
						!bat_echologlog! move /y "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak" "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!" 
						!bat_logexeclog! move /y "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak" "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!" 
					)
				!bat_popecho!

				set bat_returncode=0
			)& rem simulation...

		!bat_popecho!
	) else (
		!bat_pushecho! Using: [!bat_entervideodevice!]

			!bat_echolog! echo !bat_launchcommand!{"!bat_exedir!\!bat_entervideodevice!"

			if /i "!bat_SIMULATION.capture!" neq "true" (
			
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! [!date! !time! ]*************** START CAPTURE PROGRAM NOW ******************
				!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
				!bat_echolog! [!date! !time!] !bat_launchcommand!{"!bat_exedir!\!bat_entervideodevice!"

			
				!bat_launchcommand!<"!bat_exedir!\!bat_entervideodevice!"
				 set bat_returncode=!errorlevel!
				 
				!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
				!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
				!bat_echolog! [!date! !time! ]*************** BACK FROM  CAPTURE PROGRAM  ******************
				!bat_echolog! [!date! !time!] END: !bat_launchcommand!
				!bat_echolog! bat_logfile_full="!bat_logfile_full!" 
				!bat_echolog! [bat_returncode=!bat_returncode!]

				 
			) else (
					rem SIMULATION - 
				!bat_echolog!
				!bat_pushecho! Simulating capture---
					!bat_logexec! md "!bat_SIMULATION.CapturedFilesDir!"
					!bat_logexec! md "!bat_SIMULATION.ArchivedFilesDir!"

					!bat_echolog!
					!bat_echolog!    copy /y "!bat_SIMULATION.CapturedFilesSimSource!" "!bat_SIMULATION.CapturedFilesDir!"
					!bat_logexeclog! copy /y "!bat_SIMULATION.CapturedFilesSimSource!" "!bat_SIMULATION.CapturedFilesDir!"
				!bat_popecho!

				!bat_pushecho! Simulating detect...
					!bat_echolog!    copy /y "!bat_SIMULATION.ArchivedFilesSimSource!" "!bat_SIMULATION.ArchivedFilesDir!"
					!bat_logexeclog! copy /y "!bat_SIMULATION.ArchivedFilesSimSource!" "!bat_SIMULATION.ArchivedFilesDir!"

					if /i "!bat_CAPTURE.archive_flag!" neq "-1" (
						!bat_logexeclog! dir "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak"
						!bat_echologlog! aaaaaaaaa move /y "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak" "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!" 
						!bat_logexeclog! move /y "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!.bak" "!bat_SIMULATION.ArchivedFilesDir!\!bat_SIMULATION.detectfile!" 
					)
				!bat_popecho!

				set bat_returncode=0
			)& rem simulation

		!bat_popecho!
	)& rem if not defined bat_entervideodevice
	
	if /i "!bat_returncode!" neq "0" (
		!bat_CALLecho! "!bat_exedir!\ProcessCaptureReturnCode.bat"
	)

:LAUNCH_DUAL_CAPTURE_END
!bat_popecho! [RETURN !bat_batchfile!:LAUNCH_DUAL_CAPTURE_END] [bat_returncode=!bat_returncode!]
!bat_echolog!
!bat_return!



:GETCAPTUREDIR [in] %* 
!bat_pushlog! [CALL !bat_batchfile!:GETCAPTUREDIR] %*
	rem [out]	bat_retval
	rem [out]	bat_captureddir
	rem [out]	bat_captureddate
	rem [out]	bat_capturedbasedir


	!bat_echolog!
	!bat_echolog! Attempting to determine the directory name that !bat_captureexesrc! created...  
	!bat_echolog!
	!bat_echolog! It looks at all the subdirs of the CaptureFiles dir in date order.  The last 
	!bat_echolog! one in the list should be the most recent CapturedFiles directory.
	!bat_echolog!

	rem Careful, there is a chance that it didn't create a directory at all and 
	rem you'd be choosing the wrong dir. Compare with bat_precaptureddir to protect 
	rem against that. 

	set bat_retval=failed

	set bat_targetsearchdir=
	set bat_captureddir=
	set bat_captureddirname=
	set bat_capturedbasedir=
	set bat_captureddate=
	set bat_capturedtime=
	set bat_capturedfilesdir=
	set /a bat_capturedcount=0
	
	set bat_archivedfilesdir=
	set /a bat_archivedcount=0
	set bat_camera_temp=
	set bat_latestcal=
	set bat_midnightsecs=
	set bat_recent_error_msg=[!date! !time!] Scanning for the new CapturedFiles dir
	set bat_returncode=0
	set bat_submissionfilesdir=
	set bat_sunsettable=Using "dusk.vbs" instead
	set bat_sunsettablename=Using "dusk.vbs" instead
	set bat_temp=
	set bat_tempfile=
	set bat_VBtemp=
	
	

	!bat_logexeclog! set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles

	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
		for           /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
			if /i "%%~nxa" neq "movies" (
				if /i "%%~nxa" neq "displayJPEGS" (
					if /i "%%~nxa" neq "gefdat" (
						rem Note: This loop sets these variable each time through the loop.
						rem       When the loop is done, the last iteration will make the
						rem       needed settings.

							rem Example: bat_captureddir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
						!bat_logexeclog! set bat_captureddir=!bat_targetsearchspec!\%%~nxa

							rem example: bat_captureddirname=2012_01_18_01_00_13
						set bat_captureddirname=%%~nxa

							rem Example: bat_targetsearchdir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
						set bat_targetsearchdir=!bat_targetsearchspec!\%%~a

							rem example: bat_capturedbasedir=C:\CAMS\CapturedFiles
						set bat_capturedbasedir=%%~dpa::
						set bat_capturedbasedir=!bat_capturedbasedir:\::=!
						set bat_capturedbasedir=!bat_capturedbasedir:::=!
					)
				)
			)
		)
	!bat_poplog! ^) // for...
		
		rem Log the settings that were made in the last iteration of the loop.
	!bat_logexeclog! set bat_captured
		
	!bat_log!

	!bat_log! if not defined bat_captureddir ^(
	if           not defined bat_captureddir (
		!bat_pushecho!
			!bat_echolog! `    !bat_batchfile!:GETCAPTUREDIR - ERROR - There are no CapturedFiles directories. Interpreting that as a
			!bat_echolog! `                                   capture failure or manual abort. 
		!bat_popecho! ^) // goto GETCAPTUREDIR_END
		goto :GETCAPTUREDIR_END
	) else (
		!bat_pushlog! ^) else ^(
			!bat_echolog!  FOUND - bat_captureddir is defined [!bat_captureddir!]
		!bat_poplog! ^)
	)& rem else...


	!bat_echolog!
	!bat_log! if /i "!bat_captureddir!" equ "!bat_precaptureddir!" ^( 
	if           /i "!bat_captureddir!" equ "!bat_precaptureddir!" (
		!bat_push!
			!bat_echolog!
			!bat_echolog! !bat_batchfile!:GETCAPTUREDIR - ERROR - Capture did not produce a new directory. Interpreting that as a
			!bat_echolog! `                           capture failure. 

			set bat_targetsearchdir=
			set bat_captureddir=
			set bat_captureddirname=
			set bat_capturedbasedir=
			set bat_captureddate=
			set bat_capturedtime=
			set bat_capturedfilesdir=
			set /a bat_capturedcount=0

			set bat_archivedfilesdir=
			set /a bat_archivedcount=0
			set bat_camera_temp=
			set bat_latestcal=
			set bat_midnightsecs=
			set bat_recent_error_msg=[!date! !time!] Scanning for the new CapturedFiles dir
			set bat_returncode=0
			set bat_submissionfilesdir=
			set bat_sunsettable=Using "dusk.vbs" instead
			set bat_sunsettablename=Using "dusk.vbs" instead
			set bat_temp=
			set bat_tempfile=
			set bat_VBtemp=
		!bat_popecho! ^) // goto GETCAPTURDIR_END
		goto :GETCAPTUREDIR_END
	) else (
		!bat_pushlog! ^) else ^( 
			!bat_pushecho! Capture was a success and it produced a new CapturedFiles directory:
				!bat_echolog! "!bat_captureddir!"
				!bat_logexeclog! set bat_retval=!bat_captureddir!
				!bat_logexeclog! set bat_capturedfilesdir=!bat_captureddir!

				rem Example: bat_captureddate=2012_01_18
				!bat_logexeclog! set bat_captureddate=!bat_captureddirname:~0,10!
				!bat_logexeclog! set bat_capturedtime=!bat_captureddirname:~-8!
				!bat_logexeclog! set bat_captureddatetime=!bat_captureddirname:~0,19!

				rem Change the settings so that log files belong to the captureddate from now on...
				!bat_CALL! "!bat_exedir!\RedirectLogs.bat" "!bat_logdir!" "!bat_exedir!\Logs\!bat_captureddatetime!"
				!bat_poplog!
			!bat_popecho!

			!bat_logexeclog! set bat_cap
			!bat_logexeclog! set bat_targetsearchdir
		
		!bat_poplog! ^) // 
	)& rem else...
	
:GETCAPTUREDIR_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAPTUREDIR] [bat_retval=!bat_retval!, 
!bat_log! `                                             bat_captureddir=!bat_captureddir!, 
!bat_log! `                                             bat_captureddate=!bat_captureddate!
!bat_log! `                                             bat_capturedtime=!bat_capturedtime!]
!bat_log!
!bat_return!




	rem CHECK FOR PROBLEMS WITH CAPTURE BY CHECKING FOR THINGS IN THE 
	rem "CaptureStats.log" FILE AND CHECKING FOR SKIPPED FRAMES.
:LOGSKIPPEDFRAMES
!bat_pushlog! [CALL !bat_batchfile!:LOGSKIPPEDFRAMES]

	!bat_pushecho! Checking CaptureStats.log file...
		if not exist "!bat_captureddir!\CaptureStats.log" (
			!bat_logexeclog! set bat_autocams.abort=true
			!bat_echolog! ` ERROR - Not Found: "!bat_captureddir!\CaptureStats.log"
			!bat_echolog! `         Either CaptureAndDetect wasn't used or it was interrupted
			!bat_echolog! `         somewhere.  
			!bat_echolog!
			!bat_echolog!           YOU MUST NOW USE OPTION 44b TO COMPLETE THE DETECTION PROCESS.
			!bat_echolog!
			goto :LOGSKIPPEDFRAMES2
		) else (
			!bat_pushlog! Check if the CapturedStats.log file is zero bytes...
			set bat_retval=
			!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_captureddir!\CaptureStats.log" /s/b /a-d`^) do ^(
			for               /f "usebackq tokens=*" %%a in (`dir "!bat_captureddir!\CaptureStats.log" /s/b /a-d`) do (
				!bat_log! %%a, %%~za bytes
				if %%~za equ 0 (
					set bat_retval=1
				)
			)
			!bat_poplog! ^)

			if defined bat_retval (
				!bat_logexeclog! set bat_autocams.abort=true
				!bat_echolog! ` ERROR - 0 - Zero Byte File: "!bat_captureddir!\CaptureStats.log"
				!bat_echolog!
				goto :LOGSKIPPEDFRAMES2
			) else (
				!bat_echolog! OK - CaptureStats.log file is not 0 bytes.
			)

		)

		!bat_logexec! find /i "Stopping capture" "!bat_captureddir!\CaptureStats.log"
		if !bat_logexec_returncode! equ 0 (
			!bat_echolog! WARNING - 1 - Capture stopped early [either manually or by the capture program]
			!bat_echolog!
		)

			!bat_logexec! find /i "No frame grab complete signal" "!bat_captureddir!\CaptureStats.log"
			if !bat_logexec_returncode! equ 0 (
				!bat_echolog! WARNING - 2 - Errors in capture 
				!bat_echolog!
			)

		!bat_logexec! find /i "Capture/Writing Threads Completed" "!bat_captureddir!\CaptureStats.log"
		if !bat_logexec_returncode! equ 0 (
			!bat_echolog! `    OK - 3 - Capture/Writing Threads completed OK [but there still may or may not have been errors]
			!bat_echolog!
		)

		!bat_logexec! find /i "Finishing Detection Processing" "!bat_captureddir!\CaptureStats.log"
		if !bat_logexec_returncode! equ 0 (
			!bat_echolog! `    OK - 4 - Finished Detection Processing OK [but there still may or may not have been errors]
			!bat_echolog!
		)

		!bat_log! Checking "CaptureStats.log" for instances of "ERROR"...
		!bat_logexec! find /i "ERROR" "!bat_captureddir!\CaptureStats.log"
		if !bat_logexec_returncode! equ 0 (
			!bat_echolog! `    ERROR - 5 - ERRORS FOUND
			!bat_echolog!
		)

		!bat_logexec! find /i "Number of dropped frames" "!bat_captureddir!\CaptureStats.log"
		if !bat_logexec_returncode! equ 0 (
			!bat_echolog! OK - Capture seems to have completed.
			!bat_echolog! 
		) else (
			rem Getting here is an indication that the Capture program didn't finish
			rem properly, thus not completing the write to the CaptureStats.log file.
			!bat_logexeclog! set bat_autocams.abort=true
			!bat_echolog! ` ERROR - 6 - Capture program didn't finish properly, thus
			!bat_echolog! `             not completing the final writes to the 
			!bat_echolog! `             CaptureStats.log file:
			!bat_echolog! `        "!bat_captureddir!\CaptureStats.log"
		)

	!bat_popecho!

:LOGSKIPPEDFRAMES2
	!bat_CALL! "!bat_exedir!\skippedFrames.bat" "!bat_capturedfilesdir!" /v /ok

:LOGSKIPPEDFRAMES_END
!bat_poplog! [RETURN !bat_batchfile!:LOGSKIPPEDFRAMES] [!bat_logexec_returncode!]
!bat_log!
!bat_return!







:REPROCESSMULTI
	!bat_pushecho! [CALL !bat_batchfile!:REPROCESSMULTI] %*
	!bat_echolog!

	!bat_CALLecho! "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!" autonomous
	set bat_returncode=!errorlevel!
	
	!bat_echolog! Waiting 10 seconds...
	              !bat_WAIT!  10

:REPROCESSMULTI_END
!bat_popecho! [RETURN !bat_batchfile!:REPROCESSMULTI] [bat_returncode=!bat_returncode!, 
!bat_log! `                                               bat_capturedfilesdir=!bat_capturedfilesdir!]
!bat_log!
!bat_return!



:GETARCHIVEDDIR [out] bat_archiveddir
!bat_pushlog! [CALL !bat_batchfile!:GETARCHIVEDDIR] %*

	!bat_echolog!
	!bat_echolog! This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
	!bat_echolog! created for ArchivedFiles.  

	!bat_echolog! This FOR loop will complete with the newest directory with the specified date
	!bat_echolog! as the prefix.  Even if there are multiple directories with the same date, the 
	!bat_echolog! newest one be contained in resulting value of bat_archiveddir.

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles

	rem Iterate through the list of !bat_targetlocation!\CAMS\ArchivedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe program.  CAREFUL, there is a chance that
	rem there is no matching ArchivedFiles dir. 

	call :RESETVARS

	set bat_targetsearchdir=
	set bat_archiveddir=
	set bat_archiveddirname=
	set bat_archivedbasedir=
	set bat_archiveddate=
	set bat_archivedtime=
	set bat_archivedfilesdir=
	
	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do ^(...
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (

		!bat_echolog! !bat_targetsearchspec!\%%a

		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_temp=%%~nxa

					rem Example: bat_archiveddir=C:\CAMS\ArchivedFiles\2012_01_18_01_00_13
					set bat_archiveddir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_archiveddirname=2012_01_18_01_00_13
					set bat_archiveddirname=%%~nxa

					rem Example: bat_targetsearchdir=C:\CAMS\ArchivedFiles\2012_01_18_01_00_13
					set bat_targetsearchdir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_archivedbasedir=C:\CAMS\ArchivedFiles
					set bat_archivedbasedir=!bat_targetsearchspec!

					set bat_archiveddate=!bat_temp:~0,10!
					set bat_archivedtime=!bat_temp:~11,8!
				)
			)
		)
	)
	!bat_poplog! ^) & rem for /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (

	!bat_logexeclog! set bat_

	!bat_pushlog! if not defined bat_archiveddir ^(
		if           not defined bat_archiveddir (
			if /i "!bat_CD_flag!" neq "-1" (
				!bat_push!
					!bat_echolog!
					!bat_echolog! WARNING - Capture did not produce a new ArchivedFiles directory.
					!bat_echolog! `         Interpreting that as a capture failure or manual abort. 
				!bat_pop!
				goto :GETARCHIVEDDIR_END
			)
		) else (
			!bat_echolog! FOUND - bat_archiveddir is defined [!bat_archiveddir!]
			!bat_logexec! set bat_archivedfilesdir=!bat_archiveddir!
		)
	!bat_poplog! ^)

	!bat_pushlog! if /i "!bat_archiveddir!" equ "!bat_precaptureddirarch!" ^(
		if           /i "!bat_archiveddir!" equ "!bat_precaptureddirarch!" (

				Rem Make sure that the new archivedfiles dir name is same as captured
			!bat_pushlog! if /i "!bat_archiveddate!" neq "!bat_captureddate!" ^(
				if           /i "!bat_archiveddate!" neq "!bat_captureddate!" (
					!bat_push!
						!bat_echolog!
						!bat_echolog! `    ERROR - Capture did not produce a new ArchivedFiles directory.
						!bat_echolog! `            Interpreting that as a capture failure or manual abort. 

						set bat_targetsearchdir=
						set bat_archiveddir=
						set bat_archiveddirname=
						set bat_archivedbasedir=
						set bat_archiveddate=
						!bat_log! goto :GETARCHIVEDDIR_END
					!bat_poplog! ^)
					!bat_poplog! ^)
					!bat_poplog! ^)
					goto :GETARCHIVEDDIR_END
				)
			!bat_poplog! ^)
		) else (
			!bat_log!
			!bat_log! FOUND - "!bat_archiveddir!"
		)
	!bat_poplog! ^)

	set bat_retval=!bat_archiveddir!
	rem Example: bat_archiveddate=2012_01_18
	set bat_archiveddate=!bat_archiveddirname:~0,10!
	set bat_archivedtime=!bat_archiveddirname:~-8!
	set bat_archiveddatetime=!bat_archiveddirname:~0,19!
	set bat_archivedfilesdir=!bat_archiveddir!

	!bat_echolog!
	!bat_echolog! bat_targetsearchdir=!bat_targetsearchdir!
	!bat_echolog! bat_archiveddir=!bat_archiveddir!
	!bat_echolog! bat_archivedfilesdir=!bat_archivedfilesdir!
	!bat_echolog! bat_archiveddirname=!bat_archiveddirname!
	!bat_echolog! bat_archiveddate=!bat_archiveddate!
	!bat_echolog! bat_archiveddatetime=!bat_archiveddatetime!

	

:GETARCHIVEDDIR_END
!bat_poplog! [RETURN !bat_batchfile!:GETARCHIVEDDIR] [bat_archivedfilesdir=!bat_archivedfilesdir!];
!bat_log!
!bat_return!




:WAITFORMULTISCAN
!bat_pushlog! [CALL !bat_batchfile!:WAITFORMULTISCAN] %*

	if not exist "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" (
		!bat_echolog!
		!bat_echolog! `    ERROR - not found - "!bat_archivedfilesdir!\FTPdetectinfo_*.txt"
		goto :WAITFORMULTISCAN_END
	)

	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" /b /a-d`^) do ...
		for           /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_*.txt" /b /a-d`) do (
			!bat_echolog!
			!bat_pushecho! Waiting for FTP_Reprocess to release the file: "!bat_archivedfilesdir!\%%~nxa"
				!bat_echolog! call WaitForFile.EXE rw "!bat_archivedfilesdir!\%%~nxa"
				!bat_echolog!
				!bat_logexec! call WaitForFile.EXE rw "!bat_archivedfilesdir!\%%~nxa"
			!bat_popecho!
		)
	!bat_poplog!
	!bat_echolog!

:WAITFORMULTISCAN_END
!bat_poplog! [RETURN !bat_batchfile!:WAITFORMULTISCAN] [bat_archivedfilesdir=!bat_archivedfilesdir!]
!bat_log!
!bat_return!






:MERGECASE
!bat_pushlog! [CALL !bat_batchfile!:MERGECASE] [%*]
	if not defined bat_archivedfilesdir (
		!bat_echolog! `    ERROR - Not defined: bat_archivedfilesdir
		goto :MERGECASE_END
	)
	
	!bat_CALLecho! "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"
	set bat_returncode=!errorlevel!

	set bat_temp=
	set bat_detectfile=
	call :GETDETECTFILE

	rem Get latest cal file
	set bat_latestcal=
	if defined bat_detectfile (
		for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_detectfile!"`) do (
			if not defined bat_latestcal ( set bat_latestcal=%%a )
		)
	)

:MERGECASE_END
	set bat_temp=
!bat_poplog! [RETURN !bat_batchfile!:MERGECASE] [bat_detectfile=!bat_detectfile!]
!bat_log!
!bat_return!





:GETDETECTFILE
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*

	set bat_detectfile=
	!bat_echo! Iterate through all the FTPdetectinfo files in the ArchivedFiles dir by date/time.
	!bat_echo! Problem is, it may not have produced a new detect file... 
	!bat_echo!
	rem CAUTION: You must remember that there are several kinds of detect files that
	rem          could exist:
	rem            FTPdetectinfo_02130216_2012_08_13.txt (from FTP_CaptureTwoAndDetect.exe)
	rem            FTPdetectinfo_02130216_2012_08_13_04_13_59.txt (from newer scripts)
	rem            FTPdetectinfo_0213_2012_08_13_04_13_59.txt (from newer scripts)
	rem            FTPdetectinfo_0213_2012_08_13.txt (from older scripts)
	rem            FTPdetectinfo.txt (from real old exe and scripts)
	
	!bat_CALL! "!bat_exedir!\GetDetectFile.bat" "bat_detectfile" "!bat_archivedfilesdir!"

	if not defined bat_detectfile (
		!bat_echolog! `    ERROR - Unable to locate detect file.
		goto :GETDETECTFILE_END
	) else (
		call :GETDETECTFILE_PARSE "!bat_detectfile!"
	)

	if not exist "!bat_detectfile!" (
		!bat_echolog! `    ERROR - Unable to locate detect file.
		goto :GETDETECTFILE_END
	)
	
:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_detectfile=!bat_detectfile!]
!bat_log!
!bat_return!



:GETDETECTFILE_PARSE [in] "!bat_detectfile!"
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE_PARSE] %*
	set bat_detectfile1=%~1
	set bat_detectfile3=%~n1
	set bat_detectfile4=%~nx1
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE_PARSE] [!bat_detectfile1!, 
!bat_log! `                              !bat_detectfile3!,
!bat_log! `                              !bat_detectfile4!]
!bat_log!
!bat_return!


:WAITCAPTUREDETECT
!bat_pushlog! [CALL !bat_batchfile!:WAITCAPTUREDETECT] %*
	rem if bat_detectilfe isnt defined, then we need to run MakeCaseListing
	
	if not defined bat_detectfile (
		call :STARTDETECT
		call :GETARCHIVEDDIR
		call :GETDETECTFILE
	)

	if not exist "!bat_detectfile!" (
		!bat_echolog! `    ERROR - No detect file
		goto :WAITCAPTUREDETECT_END
	)
	
	!bat_logexec! WaitForFile rw "!bat_detectfile!"
	!bat_echolog!
	!bat_echolog! `    "!bat_detectfile!" is ready to use...
	!bat_echolog!

:WAITCAPTUREDETECT_END
!bat_poplog! [RETURN !bat_batchfile!:WAITCAPTUREDETECT] [bat_detectfile=!bat_detectfile!]
!bat_log!
!bat_return!



:STARTDETECT
!bat_pushlog! [CALL !bat_batchfile!:STARTDETECT] [%*]
	!bat_CALLecho! "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"

:STARTDETECT_END [%*]
!bat_poplog! [RETURN !bat_batchfile!:STARTDETECT] []
!bat_log!
!bat_return!




:COPYARCHIVED
!bat_pushecho! [CALL !bat_batchfile!:COPYARCHIVED] %*

	!bat_echo! This is done because we use the "bat_CAPTURE.archive_flag" using
	!bat_echo! the "move" option [2].  With the "move" option, when detect is complete,
	!bat_echo! the detected .bin files are 'moved' [not copied] to the ArchivedFiles
	!bat_echo! dir to save on I/O and CPU usage.  Therefore, in order to restore 
	!bat_echo! the CapturedFiles dir so that it contains a complete list of all 
	!bat_echo! captured files [in case detection needs to be re-run], the detected 
	!bat_echo! files are copied back to the CapturedFiles dir.
	!bat_echo!
	!bat_logexeclog! copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"
	set bat_returncode=!bat_logexec_returncode!
	
	set bat_retval=failed
	if !bat_returncode! equ 0 (
		set bat_retval=success
	)
	
	rem [CONFIRMATION]
	rem min.track.length.frames=3
	rem sortbycamera=true

	if /i "!bat_CONFIRMATION.sortbycamera!" equ "true" (
		if "!bat_archivedmeteorcount!" LEQ "!bat_CONFIRMATION.sort.max" (
			!bat_CALLecho! "!bat_exedir!\SortDetect.bat" "!bat_detectfile!"
		)
	)

:COPYARCHIVED_END
!bat_popecho! [RETURN !bat_batchfile!:COPYARCHIVED] [bat_retval=!bat_retval!, bat_returncode=!bat_returncode!]
!bat_echolog!
!bat_return!






	rem Get values to store into AutoCams.bat.ini
:POSTCAPTURE
!bat_pushlog! [CALL !bat_batchfile!:POSTCAPTURE] %*
	set bat_retval=postcapture success

	!bat_log! if not exist "!bat_detectfile!" ^(
	if           not exist "!bat_detectfile!"  (
		set bat_retval=postcapture failed
		!bat_echolog! `    "!bat_logfile!"
		!bat_echolog!
		!bat_echolog! `    ERROR - detect file "!bat_detectfile!" not found...
		!bat_echolog!
		
		!bat_logexeclog! dir "!bat_archiveddir!\ftpdetect*.*" /s/b /a-d /od
		goto :POSTCAPTURE_END
	) else (
		!bat_log! ...OK - exists
	)

	set /a bat_capturedcount=0
	if exist "!bat_captureddir!\*.bin" (
		!bat_log! for /f "usebackq tokens=*" ..b in ^(`dir "!bat_capturedfilesdir!\*.bin" /a-d /b^|find /i /c ".bin"`^) do ^(
		for           /f "usebackq tokens=*" %%b in  (`dir "!bat_capturedfilesdir!\*.bin" /a-d /b^|find /i /c ".bin"`) do (
			set /a bat_capturedcount=%%~b
		)
	) else (
		set bat_retval=postcapture failed
		!bat_log! ERROR - Doesn't exist "!bat_captureddir!\*.bin"
	)
	!bat_echolog! [CapturedDir file count=!bat_capturedcount!]    !bat_captureddir!
	!bat_echolog!

	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	set bat_archivedfilesdir=!bat_archiveddir!


		rem Get the bat_archivedcount by counting the number of .bin files in the archivedfiles dir
		rem bat_archivedcount is the number of FF*.bin files where bat_archivedmeteorcount is the
		rem number of detections in the detect file. 
	set bat_archivedcount=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\*.bin"^|find /i /c ".bin"`) do (
		set bat_archivedcount=%%~a
	)

	set bat_recent_error_msg=[!date! !time!] !bat_batchfile!:POSTCAPTURE [%~nx0 %*]
	!bat_CALL! "!bat_exedir!\SaveConfig.bat" 

	!bat_echolog!
	!bat_pushlog! Here is what's in the configuration file [!bat_configfile!]:
		!bat_logexeclog! type "!bat_configfile!"
	!bat_poplog!

:POSTCAPTURE_END
!bat_poplog! [RETURN !bat_batchfile!:POSTCAPTURE] [!bat_retval!, 
!bat_log! `                                           bat_captureddir=!bat_captureddir!]
!bat_return!










:JUNK
	!bat_log! !bat_batfile!:JUNK %*
	!bat_logexeclog! type "!bat_configfile!

	!bat_log!
	!bat_log! =========== :JUNK %* ==================
rem	pause
!bat_return!


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	!bat_CALL! "!bat_exedir!\Date2JDate.bat" %1 %2 %3 %4
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	!bat_CALL! "!bat_exedir!\JDate2Date.bat" %1 %2 %3 %4
EXIT /b 0





:SETCAPTUREEXE
!bat_pushlog! [CALL !bat_batchfile!:SETCAPTUREEXE] %*
	rem [in]	
	rem [out]	bat_captureexesrc
	rem [out]	bat_captureexe
	rem	[out[	bat_capturebat
	rem [out]	bat_CD_flag

	rem These settings are now handled by the following parameters in the
	rem AutoCams.Params.ini file:
	rem  - capture_mode=capture, captureanddetect, or capturetwoanddetect
	rem  - bat_capturebat=FTP_Capture.bat, CaptureAndDetect.bat, or CaptureTwoAndDetect.bat
	rem  - bat_captureexe=FTP_Capture.exe, FTP_CaptureAndDetect.exe, or FTP_CaptureTwoAndDetect.exe
	rem  - bat_captureexesrc=FTP_Capture.exe, FTP_CaptureAndDetect.exe, or FTP_CaptureTwoAndDetect.exe
	rem  - archive_flag=-1, 0, 1, or 2
	rem  - cameralist=213, or 213 216

%bat_COMMENT_BEGIN%
	if /i "!bat_CAPTURE.capture_mode!" equ "capture" (
		set bat_CD_flag=
		goto :SETCAPTUREEXE_END
	)
%bat_COMMENT_END%	

:SETCAPTUREEXE_END
		!bat_echolog! ` Capture mode in AutoCams.Params.ini is:
		!bat_echolog! `     "!bat_CAPTURE.capture_mode!" 
		!bat_echolog! `     so using:
		!bat_echolog! `       archive_flag=!bat_CAPTURE.archive_flag!
		!bat_echolog! `       cameralist=!bat_CAPTURE.cameralist!
		!bat_echolog! `       !bat_capturebat!
		!bat_echolog! `       !bat_captureexe!
		!bat_echolog! `       !bat_captureexesrc!
		!bat_echolog! `       !bat_CAPTURE.delete.during.capture!
!bat_poplog! [RETURN !bat_batchfile!:SETCAPTUREEXE] [src=!bat_captureexesrc!, dest=!bat_captureexe!]
!bat_echolog!
!bat_return!




	rem Essentially, a copy of the executable (bearing the camera number) is run instead 
	rem of the normal executable.  This allows you to monitor it using Task Manager.  
	rem More importantly, if one camera fails and the other continues OK, you can ensure 
	rem that the failed camera's processis terminated (using process.exe) before the 
	rem capture for that camera is started again. For dual-camera mode, this is ignored 
	rem and the bat_captureexe and the bat_captureexesrc values should be the same.
:COPYEXE
!bat_pushlog! [CALL !bat_batchfile!:COPYEXE] %*
	rem [uses]	bat_captureexesrc
	rem [uses]	bat_captureexe

	!bat_logexeclog! copy /y "!bat_exedir!\!bat_captureexesrc!" "!bat_exedir!\!bat_captureexe!"

:COPYEXE_END 
	!bat_poplog! [RETURN !bat_batchfile!:COPYEXE] [!bat_captureexe!]
!bat_log!
!bat_return!





	rem This reads the "AutoCams.Params.ini" file for 
	rem sections, keys, and values.  The keys and values
	rem are in the format of autonomouslevel=cal.  
	rem 
	rem If the environment variable is not a [section] then it
	rem is either a key or a comment.  
	rem 
	rem A comment is any line that starts with "//" or "rem ". 
	rem 
	rem If the key starts with "bat_", then the environment variable
	rem will bet set without the section prefix.  Otherwise, the
	rem environment variable will be set with the section 
	rem prefix.
	rem
	rem Examples:
	rem  [AUTOCAMS]
	rem  autonomouslevel=apply
	rem
	rem This would result in the following command being executed:
	rem set AUTOCAMS.autonomouslevel=apply
	rem
	rem  [CALIBRATION]
	rem  bat_calnstars=80
	rem
	rem This would result in the following command being executed (Note how
	rem the section name is not prefixed):
	rem set bat_calnstars=80
	rem
	rem The reason for the different treatment is to make the ini file
	rem compatible with some script variables that were in use before
	rem the AutoCams system was expanded to using this AutoCams.Params.ini 
	rem file. 
	rem
	rem Place this section of code into:
	rem		AutoCams.bat
	rem  	StageFromConfirmed.bat
	rem 	ValidateCal.bat
	rem     LaunchCapture.bat
	rem     CaptureAndDetect.bat
	rem     CaptureTwoAndDetect.bat
	rem
:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_CALL! "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!


:RESETVARS
!bat_pushlog! [CALL !bat_batchfile!:RESETVARS] 
	set bat_archivedfilesdir=
	set bat_archivedcount=
	set bat_bat_borrow=
	set bat_calcedon=
	set bat_calnstars=
	set bat_caloc=
	set bat_curh=
	set bat_curm=
	set bat_curs=
	set bat_cursec=
	set bat_curtime=
	set bat_date=
	set bat_dawnutc=
	set bat_day=
	set bat_dd=
	set bat_delay=
	set bat_delaycalc=
	set bat_delayhh=
	set bat_delaymm=
	set bat_delayss=
	set bat_delaytemp=
	set bat_delay_h=
	set bat_delay_m=
	set bat_diskspacememo=
	set bat_divide=
	set bat_dst=
	set bat_dur=
	set bat_durh=
	set bat_durm=
	set bat_durs=
	set bat_durtotalsecs=
	set bat_dusklocal=
	set bat_duskutc=
	set bat_estCapFiles=
	set bat_estSizeMB=
	set bat_free=
	set bat_freeMB=
	set bat_inisection=
	set bat_int=
	set bat_JD=
	set bat_latestcal=
	set bat_midnightsecs=
	set bat_mm=
	set bat_mod=
	set bat_msg=
	set bat_newh=
	set bat_newm=
	set bat_news=
	set bat_nz=
	set bat_off=
	set bat_offh=
	set bat_offm=
	set bat_offs=
	set bat_offsec=
	set bat_offtime=
	set bat_on=
	set bat_onh=
	set bat_onm=
	set bat_ons=
	set bat_onsec=
	set bat_remainder=
	set bat_reqdisk=
	set bat_res1=
	set bat_res2=
	set bat_res3=
	set bat_sa_off=
	set bat_sa_on=
	set bat_scheduledstarttime=
	set bat_size=
	set bat_sizediff=
	set bat_startcountthreshold=
	set bat_submissionfilesdir=
	set bat_sunangleoff=
	set bat_sunangleon=
	set bat_sunsettable=
	set bat_targetfreespace=
	set bat_temph=
	set bat_tempm=
	set bat_tenth=
	set bat_th1=
	set bat_th3=
	set bat_th4=
	set bat_tm1=
	set bat_tm3=
	set bat_tm4=
	set bat_ts1=
	set bat_ts3=
	set bat_ts4=
	set bat_unique=
	set bat_walltimeroff=
	set bat_wdayn=
	set bat_weekday=
	set bat_year=
	set bat_yyyy=
	
	
	
	
	
:RESETVARS_END
!bat_poplog! [RETURN !bat_batchfile!:RESETVARS] []
!bat_return!


:VARIABLES_LOG
!bat_pushlog! [CALL !bat_batchfile!:VARIABLES_LOG] []
	!%~1! set bat_
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`set bat_`) do (
		!%~1! %%a
	)
	!%~1!
	!bat_pop!

	!%~1! set ftp_
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`set ftp_`) do (
		!%~1! %%a
	)
	!%~1!
	!bat_pop!

:VARIABLES_LOG_END
!bat_poplog! [RETURN !bat_batchfile!:VARIABLES_LOG] []
!bat_log!
!bat_return!




******************************************************************
	CaptureStats.log:
		Finishing Detection Processing
		Capture/Writing Threads Completed
		No frame grab complete signal on camera CCC
		Number of dropped frames
		Stopping capture
*******************************************************************



:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     %~n0 can be run by double-clicking on the program from 
    echo     Windows or from a command line.
    echo.
    echo     Starting it from Windows, it will run it in interactive mode 
    echo     where it will prompt the user for the camera number and the 
    echo     duration of the capture in hours.  
    echo.
    echo     If the duration entered is zero, then the user is prompted to 
    echo     manually start and stop the capture process.  If the duration 
    echo     is greater than zero, the program automatically starts the 
    echo     capture and stops after the designated time has elapsed. 
    echo.
    echo     If you run it from a command shell or batch script, you 
    echo     can specify the camera number and duration as command-line 
    echo     arguments.  If the command-line arguments don't provide all 
    echo     the necessary parameters, the missing parameters will be 
    echo     prompted for.
    echo.
    echo     Usage: %~nx0 [SCANMODE] [cameranumber] [duration] ["targetdirectory"] [autonomous] [/?]
    echo.
    echo     Examples:
    echo         CaptureAndDetect
    echo                                          The user is prompted for 
    echo                                          camera number, duration, 
    echo                                          and base target dir.
    echo.
    echo         CaptureAndDetect 2 299                  The user is prompted for 
    echo                                          capture duration and base 
    echo                                          target dir.
    echo.
    echo         CaptureAndDetect 2 299 0.0              The user is prompted for 
    echo                                          for the base target dir and
    echo                                          prompted to start and stop. 
    echo.
    echo         CaptureAndDetect 2 299 9.5              The user is prompted for 
    echo                                          the base target dir. 
    echo.
    echo         CaptureAndDetect 2 299 9.5 "h:\2011"   The capture for camera 299
    echo                                          starts and runs for 9 hrs  
    echo                                          and 30 mins and saves the
    echo                                          data to a directory like:
    echo                      h:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05
    echo.
    echo     Note: Directory names should be surrounded by quotes.
    echo.
    echo     A folder is created for saving the FF files based on the date and 
    echo     universal time (UTC) at the start of the capture.  The higher level 
    echo     directory is always user specified and the \CAMs\CapturedFiles\ is 
    echo     appended along with the start date and time.  For example, a 
    echo     capture that starts on Aug 14, 2011, 5:11:05 UTC and the target 
    echo     directory specified was "C:", the target directory would be created 
    echo     as C:\CAMS\CapturedFiles\2011_08_14_05_11_05.  If the target dir
    echo     of "D:\2011" is specified, the target directory would be created as:
    echo     C:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05.  
    echo.
    echo     AUTONOMOUS mode:
    echo       You have the option to run capture in autonomous mode. In 
	echo       autonomous mode, it will complete the capture, perform a
	echo       automatic Meteor Cal Update, Apply the Cal to the detect
	echo       file, run the submission script, create a zip file, and 
	echo       (in the future, upload the zip file to the ftp server).
    echo.    
EXIT /b -99
    
goto :DONE


:DONE

	!bat_logexeclog! type "!bat_paramsfile!"
	!bat_logexeclog! type "!bat_configfile!"
	!bat_logexeclog! set bat_

	!bat_pop!
	!bat_echolog! END OF %~nx0  ******  %date% %time%
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	if /i "!bat_anonymous!" equ "anonymous" (
		AutoCams.bat
	) else (
		exit
	)
