 @echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	!bat_CALL! "!bat_exedir!\ReadParams.bat"
	

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! Twilight file: "Steve Script 1.0"
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadConfig.bat"
	
   	set bat_tempfile=%~0.junk.txt
	set bat_warningfile=%~0.warn.txt
	set bat_sunsettable=Script Steve v1.00
	
	rem If the first argument is blank, then use the bat_currdate returned from the first call to GETDATE2.bat
	set bat_twilight_searchstr=%~1

	if /i "!bat_twilight_searchstr!" equ "" (
		set bat_twilight_searchstr=!date!
	)


	!bat_CALL! "!bat_exedir!\GETDATE2.bat" !bat_twilight_searchstr:~-10!
	
	!bat_CALL! "!bat_exedir!\PARSEDATE1.bat" !bat_currdate!
	
	set bat_curryyyy=!ftp_year!
	set bat_currmo=!ftp_mo!
	set bat_currda=!ftp_da!
	
	if not defined bat_currdate (
		!bat_echolog!
		!bat_echolog! '    ERROR - GETDATE2.bat failed.
		!bat_echolog!
	)
	
	!bat_logexeclog! set bat_curdate=!bat_currdate!
	!bat_CALL! "!bat_exedir!\PARSEDATE1.bat" !bat_currdate!


	rem Date in CAMS format "YYYY_MM_DD"
	!bat_log! CAMs date is bat_date_cams=!bat_date_cams!

	
:DAYOFWEEK
	!bat_CALL! "!bat_exedir!\date2jdate.bat" bat_JD_jan1 !ftp_year! 01 01
	!bat_CALL! "!bat_exedir!\date2jdate.bat" bat_JD !ftp_year! !ftp_mo! !ftp_da!
	!bat_CALL! "!bat_exedir!\jdate2date.bat" !bat_JD! bat_yyyy bat_mm bat_dd
	
	set /a bat_day_number=!bat_JD! - !bat_JD_jan1! + 1

		rem returns bat_weekday
	!bat_CALL! "!bat_exedir!\DayOfWeek.bat" "!bat_currdate!"
	set bat_weekday=!bat_retval!

	Rem echo !bat_curdate!, !bat_yyyy!/!bat_mm!/!bat_dd!, JD=!bat_jd!, !bat_wdayn!, !bat_weekday!

        
	set delimiter=!bat_LOCALIZE.delimiter.csv!
	set decimalseparator=!bat_LOCALIZE.separator.decimal!

goto :MAIN %*



:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] [%*]

	!bat_logexeclog! set ftp_wmdy=!bat_twilight_searchstr!
	!bat_logexeclog! set bat_formatdate=!bat_LOCALIZE.format.date!


	!bat_log! Calling "dusk.vbs" to get the twilight dusk/dawn and camera on/off info.
	!bat_log! for /f "delims=" ..a in ^('cscript //nologo dusk.vbs %ftp_year% %ftp_mo% %ftp_da%'^) do ^(
	          for /f "delims=" %%a in  ('cscript //nologo dusk.vbs %ftp_year% %ftp_mo% %ftp_da%') do (
		!bat_logexeclog! set bat_VBTemp=%%a
	)

	for /f "tokens=1-16 delims=;" %%a in ("%bat_VBTemp%") do (
                
                set bat_onUT=%%a
		set bat_on=%%a
		set bat_duskutc=%%a
		set bat_calcedon=%%a
		
		set bat_dusklocal=%%b
		
		set bat_offset1=%%c
		
		set bat_off=%%d
		set bat_offUT=%%d
		set bat_dawnutc=%%d
		
		set bat_offtime=%%e
		set bat_offLocal=%%e
		
		set bat_offset2=%%f
		
		set bat_duration=%%g
		set bat_dur=%%g
		
		Set /a bat_durtotalsecs=%%h
		
                set bat_UTcurrent=%%i

		set ftp_hhmmssdd=%%j
		
		set bat_delaycalc=%%k
		
		set bat_walltimeron=%%l
		set bat_scheduledstarttime=%%l
		
		set bat_walltimeroff=%%m
		
		set bat_camera_temp=%%n
		
		set bat_lat=%%o
		
		set bat_lon=%%p
	)
	
	
	!bat_pushlog! dusk.vbs calculated the following values:
		!bat_log!   bat_on:					!bat_on!
		!bat_log!   bat_onUT:				!bat_onUT!
		!bat_log!   bat_duskutc:				!bat_duskutc!
		!bat_log!   bat_calcedon:			!bat_calcedon!
		!bat_log!
		!bat_log!   bat_dusklocal:			!bat_dusklocal!
		!bat_log!
		!bat_log!   bat_offset1:				!bat_offset1!
		!bat_log!
		!bat_log!   bat_off:					!bat_off!
		!bat_log!   bat_offUT:				!bat_offUT!
		!bat_log!   bat_dawnutc:				!bat_dawnutc!
		!bat_log!
		!bat_log!   bat_offtime:				!bat_offtime!
		!bat_log!   bat_offLocal:			!bat_offLocal!
		!bat_log!
		!bat_log!   bat_offset2:				!bat_offset2!
		!bat_log!
		!bat_log!   bat_duration:			!bat_duration!
		!bat_log!
		!bat_log!   bat_durtotalsecs:		!bat_durtotalsecs!
		!bat_log!
		!bat_log!   bat_UTcurrent:			!bat_UTcurrent!
		!bat_log!
		!bat_log!   ftp_hhmmssdd:			!ftp_hhmmssdd!
		!bat_log!
		!bat_log!   bat_delaycalc:			!bat_delaycalc!
		!bat_log!
		!bat_log!   bat_walltimeron:		!bat_walltimeron!
		!bat_log!   bat_scheduledstarttime	!bat_scheduledstarttime!
		!bat_log!
		!bat_log!   bat_walltimeroff:		!bat_walltimeroff!
		!bat_log!
		!bat_log!	bat_camera_temp:			!bat_camera_temp!
		!bat_log!
		!bat_log!   bat_lat:					!bat_lat!
		!bat_log!
		!bat_log!   bat_lon:					!bat_lon!
	!bat_pop!


			call :CALCDAYNUMBER %bat_twilight_searchstr%

			echo.	Task Scheduler Start Time (Wall timer ON)=!bat_scheduledstarttime!
			echo.
			echo 	Task Scheduler Stop Time (Wall timer OFF)=!bat_walltimeroff!
			echo.
			echo    Date=               %bat_twilight_searchstr%  - Date of these calculations ^(!bat_weekday!^)
			echo    Day number=         !bat_day_number!         - Day of the year 
			echo    Task Sched Start    !bat_scheduledstarttime!    - Local time Windows Task Scheduler is supposed to launch this script
			echo    Current Time        !ftp_hhmmssdd!    - Current local time
			echo.
			echo    Camera ON=          %bat_dusklocal% (UT%bat_offset1%)   - Local time Task Scheduler should start capture
			echo    Camera ON UTC       %bat_onUT%     - UTC time ^(camera time^) of the first frame
			echo    Camera ON sun angle !bat_CAPTURE.sunangle_dusk! - degrees below horizon
			echo.
			echo    Camera OFF UTC       %bat_offUT%   - UTC time ^(camera time^) of the last frame
			echo    Camera OFF Local=    %bat_offtime% (UT%bat_offset2%)   - Local time capture should end in the morning
			echo    Camera OFF sun angle !bat_CAPTURE.sunangle_dawn! - degrees below horizon
			echo.

			echo    Duration=            %bat_dur%      - Number of hours to capture ^(24:00:00 - ON + OFF^)
			echo    Delay=               %bat_delaycalc%       - Number of seconds to delay from the current time
			echo                                      Note: Dawn is calculated for the next morning

			set /a bat_estCapFiles=!bat_durtotalsecs!0000 / 85333
			set /a bat_estSizeMB=!bat_estCapFiles!*11723 / 10000
			set /a bat_reqdisk=!bat_estSizeMB!*!bat_AUTOCAMS.diskspacewarning.days!*!bat_CAPTURE.number.of.cameras!

			!bat_CALL! "str_math.bat" -command "[math]::round(!bat_estSizeMB! / 1024,3)">nul:
			echo    Disk space required per night per camera=!bat_retval! GB
			echo    Disk space warning days=!bat_AUTOCAMS.diskspacewarning.days!

			!bat_CALL! "str_math.bat" -command "[math]::round(!bat_reqdisk! / 1024,3)">nul:
			echo    Estimated space requirements for the next !bat_AUTOCAMS.diskspacewarning.days! nights is roughly: !bat_retval! GB
			echo.
			echo    To check how much disk space you will require over the next !bat_AUTOCAMS.diskspacewarning.days! days, 
			echo    execute this command:
			        !bat_CALL! "!bat_exedir!\checkfreespace.bat" !bat_exedrive! !bat_durtotalsecs!
			echo.
			echo        [Note: See the AutoCams.Params.ini file to adjust these warnings:
			echo           [AUTOCAMS]
			echo           diskspacewarning.days=!bat_AUTOCAMS.diskspacewarning.days!
			echo.
		)
	)


:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] []
	set bat_VBTemp=
goto :DONE











:CALCDAYNUMBER
	Rem Usage: call :CALCDAYNUMBER day
	Rem   where day is the day number from the sunsettable.txt file.  In that file,
	Rem   the day number in in the file for the first date (01/01/2011) has a value
	Rem   of zero.  It should be reported as day 1 and 12/31/2011 is 365 and
	Rem   01/01/2012 is day 365, which should be reported as day 1 of year 2012. 
	Rem   The only thing that should be an issue between different people using this
	Rem   is the bat_offset number below (109600), which may need to be adjusted 
	Rem   depending how how many days of offset from a daylight savings date
	Rem   is used as the base date.  
	Rem
	Rem   The 109600 number is essentially 1096.00, which represents 3 years
	Rem   before. This algorithm is based on knowning that the 1st day of the 
	Rem   year 3 years before is a known day of the week.

	!bat_CALL! "!bat_exedir!\date2jdate.bat" bat_JD_jan1 !bat_curryyyy! 01 01
	!bat_CALL! "!bat_exedir!\date2jdate.bat" bat_JD !bat_curryyyy! !bat_currmm! !bat_currdd!
	!bat_CALL! "!bat_exedir!\jdate2date.bat" !bat_JD! bat_yyyy bat_mm bat_dd
	
	set /a bat_day_number=!bat_JD! - !bat_JD_jan1! + 1

exit /b !bat_day_number!



:ERR1
	echo.
	echo ERROR - Date not found: "!bat_currmm!/!bat_currdd!/!bat_curryyyy!" in "!bat_sunsettablename!"
	echo.
goto :DONE



:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	Rem     -- in_val1    [in]  - zero leading number
	Rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b




:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	Rem                        -- JD   [out] - julian days
	Rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	Rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	Rem                        -- DD   [in]  - gregorian day, i.e. 31
	!bat_CALL! "!bat_exedir!\Date2JDate.bat" %1 %2 %3 %4
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	Rem                     -- JD   [in]  - julian days
	Rem                     -- YYYY [out] - gregorian year, i.e. 2006
	Rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	Rem                      -- DD   [out] - gregorian day, i.e. 31
	!bat_CALL! "!bat_exedir!\JDate2Date.bat" %1 %2 %3 %4
EXIT /b 0




:HELP
	echo %~nx0
	echo.
	echo  Usage: %~nx0 [date]
	echo.
	echo  Where:
	echo.
	echo   date		Is optional.  If you use the date argugment, it must be
	echo       		in the format of the US dates (yyyy/mm/dd).  If you omit
	echo       		the date argument, it assumes the current date from the 
	echo       		computer's %%date%% environment variable. 
	echo.
	echo  Examples:
	echo.
	echo   CheckTwilight
	echo      Will produce the report for the current date.
	echo.
	echo   CheckTwilight 12/31/2011
	echo      Will produce the report for December 31, 2011
	echo.
	echo  This script presents a report on the dusk/dawn information based on
	echo  the "twilight.csv.txt".  
	echo.
	echo  The "twilight.csv.txt" file should be customized for each site or 
	echo  area. Complete instructions can be found in the Cams.PDF documentation. 
	echo  In general, the file is customized using the the following steps:
	echo    1^) Use Microsoft Excel 2007 or 2010 for the "twilight.xlsm" file
	echo    2^) Edit the fields in yellow to match the values for your station
	echo    3^) File ^> Save As...
	echo    4^) Select "CSV ^(Comma delimted^) ^(*.csv^)"
	echo    5^) Name the file as "twilight.csv"
	echo    6^) Close Excel
	echo    7^) In the AutoCams.Params.ini file [CAPTURE] section, set the 
	echo        bat_sunsettablename= value to the name of the output CSV file. 
	echo    8^) Rename the output file "twilight.csv" to "twilight.csv.txt"
	echo    9^) Run CheckTwilight.bat and look for errors in the report
	echo.
	echo  The script displays the entry that contains the specified
	echo  date in table form.  Then it provides an intepreted report
	echo  in list form.  
exit /b

	
:DONE
!bat_poplog! [%date% %time%] !bat_batchfile!:DONE
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
exit /b 0
