@echo off

setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
	if "%~1" equ "" goto :HELP



:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait... 
	!bat_pushecho!

	
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! Invalid path ["!bat_targetdir!"]
		set bat_returncode=1
		goto :DONE
	)
	
	set bat_first=1
	set bat_filter=false
	if "%~2" neq "" (
		set bat_first=%~2
		set bat_filter=true
	)

	set bat_last=999
	if "%~3" neq "" (
		set bat_last=%~3
		set bat_filter=true
	)
	

	set bat_summaryfile=!bat_targetdir!\gefdat\SummaryOrbitLog.txt
	set bat_rejectsfile=!bat_targetdir!\gefdat\RejectedOrbitLog.txt
	
	set bat_outputfile=!bat_targetdir!\gefdat\CoincidenceSummaryByCamera_!bat_first!-!bat_last!.txt

	echo.!bat_summaryfile!
	echo.
	if exist "!bat_outputfile!" (
		del /q "!bat_outputfile!"
	)
	
	
	rem Trimming constants:
	set bat_rptLeft=30
	set bat_rptCameraList=300
goto :MAIN




:MAIN
!bat_log! [GOTO !bat_batchfile!:MAIN] %*

	REM create the report header:
	echo.!bat_summaryfile!>"!bat_outputfile!"
	echo.>>"!bat_outputfile!"



	echo.
	echo.!bat_summaryfile!
	echo.
	echo.Summary by Camera
	echo.
	echo.Cam   Count
	echo.---   -----


	REM Loop through all camera numbers...
	for /L %%x in (!bat_first!,1,!bat_last!) do (
		rem !bat_echo! camera %%x
		title camera %%x
		set bat_camera=000%%x
		set bat_camera=!bat_camera:~-3!

		find /c /i "_!bat_camera!" "!bat_summaryfile!">nul 2>&1
		if !errorlevel! equ 0 (
			call :PROCESS_CAMERA
		)
	)

	call :REPORTSUMMARY

	call :REPORTCOUNTS

	call :CLEANUP	


!bat_log! [END-!bat_batchfile!:MAIN] - goto :DONE


goto :DONE





	rem By this point, we've established that there is an entry for a camera.
	rem This routine outputs the camera number and the number of coincidences. 
:PROCESS_CAMERA
!bat_pushlog! [CALL !bat_batchfile!:PROCESS_CAMERA] %*

	set bat_returncode=0
	
	set bat_count=n/a
	
	rem !bat_echo! for /f "usebackq tokens=1-3" ..a in ^(`find /i /c "_!bat_camera!" "!bat_summaryfile!"`^) do ^(
	for                /f "usebackq tokens=1-3" %%a in  (`find /i /c "_!bat_camera!" "!bat_summaryfile!"`) do (
		rem !bat_echo!.%%a, %%b, %%c

		set bat_count=0000%%c
		set bat_count=!bat_count:~-4!
	)

	
	echo.!bat_camera!   !bat_count!
	set bat_reportline=!bat_camera!   !bat_count!

	echo.!bat_reportline!>>"!bat_outputfile!"

:PROCESS_CAMERA_END
!bat_poplog! [RETURN !bat_batchfile!:PROCESS_CAMERA] [bat_returncocde=!bat_returncode!]
!bat_log!
!bat_return!






:REPORTSUMMARY
!bat_pushlog! [CALL !bat_batchfile!:REPORTSUMMARY] %*


	echo.>>"!bat_outputfile!"
	echo.
	echo.>>"!bat_outputfile!"
	echo.
	echo."!bat_summaryfile!">>"!bat_outputfile!"
	echo."!bat_summaryfile!"
	
	set /a bat_count=0
	set /a bat_header=0
	for       /f "usebackq tokens=*" %%a in  (`type "!bat_summaryfile!"`) do (
		set bat_temp=%%a
		set bat_left=!bat_temp:~0,%bat_rptLeft%!
		set bat_right=!bat_temp:~%bat_rptCameraList%,999!
		
		if !bat_header! lss 3 (
			set /a bat_header+=1
			echo.    	!bat_left! !bat_right!>>"!bat_outputfile!"
			
		) else (
			title [!bat_count!.]   [!bat_first! - !bat_last!] !bat_left!   !bat_right!

			rem At this point, we could filter out all cameras not belonging to the list of
			rem cameras between bat_first and bat_last.  This would be done with another 
			rem loop that scans the bat_right variable for all those within that range.


			if /i "!bat_filter!" neq "true" (
				set /a bat_count+=1
				echo.[!bat_count!.]	!bat_left! !bat_right!
				echo.[!bat_count!.]	!bat_left! !bat_right!>>"!bat_outputfile!"
			) else (
				set bat_found=
				for /L %%b in (!bat_first!,1,!bat_last!) do (
					set bat_cam=00%%b
					set bat_cam=!bat_cam:~-3!

					echo.!bat_right!|find /i "_!bat_cam!">nul
					set bat_returncode=!errorlevel!
					if !bat_returncode! equ 0 (
						if not defined bat_found (
							set bat_found=true
							set /a bat_count+=1

							echo.[!bat_count!.]	!bat_cam!	!bat_left!	!bat_right!
							echo.[!bat_count!.]	!bat_left! !bat_right!>>"!bat_outputfile!"
							title [!bat_count!.]   [!bat_first! - !bat_last!] !bat_left!   !bat_right!
						)
					) else (
						title [!bat_count!.]   [!bat_first! - !bat_last!] !bat_left!   !bat_right! skipped
					)
				)
			)

		)
	)

	echo.Total Orbits: !bat_count!
	echo.Total Orbits: !bat_count!>>"!bat_outputfile!"

	echo.
	echo.>>"!bat_outputfile!"
	echo.
	echo.>>"!bat_outputfile!"

	echo."!bat_rejectsfile!"
	echo."!bat_rejectsfile!">>"!bat_outputfile!"

	set /a bat_count=0
	set /a bat_header=0
	for       /f "usebackq tokens=*" %%a in  (`type "!bat_rejectsfile!"`) do (
		set bat_temp=%%a
		set bat_left=!bat_temp:~0,%bat_rptLeft%!
		set bat_right=!bat_temp:~%bat_rptCameraList%,999!

		if !bat_header! lss 3 (
			set /a bat_header+=1
			echo.    	!bat_left! !bat_right!>>"!bat_outputfile!"
		)else (

			if /i "!bat_filter!" neq "true" (
				set /a bat_count+=1
				echo.[!bat_count!.]	!bat_left! !bat_right!
				echo.[!bat_count!.]	!bat_left! !bat_right!>>"!bat_outputfile!"
			) else (
				rem At this point, we could filter out all cameras not belonging to the list of
				rem cameras between bat_first and bat_last.  This would be done with another 
				rem loop that scans the bat_right variable for all those within that range.

				set bat_found=
				for /L %%b in (!bat_first!,1,!bat_last!) do (
					set bat_cam=00%%b
					set bat_cam=!bat_cam:~-3!

					echo.!bat_right!|find /i "_!bat_cam!">nul
					set bat_returncode=!errorlevel!
					if !bat_returncode! equ 0 (
						if not defined bat_found (
							set bat_found=true
							set /a bat_count+=1

							echo.[!bat_count!.]	!bat_cam!	!bat_left!	!bat_right!
							echo.[!bat_count!.]	!bat_left! !bat_right!>>"!bat_outputfile!"
						)

					) else (
						rem echo not found [!bat_right!]
					)
				)
			)
		)
	)


	echo.Total Rejected: !bat_count!
	echo.Total Rejected: !bat_count!>>"!bat_outputfile!"



:REPORTSUMMARY_END
!bat_poplog! [RETURN !bat_batchfile!:REPORTSUMMARY] [bat_returncocde=!bat_returncode!]
!bat_log!
!bat_return!




:REPORTCOUNTS
!bat_pushlog! [CALL !bat_batchfile!:REPORTCOUNTS] %*

	echo.
	echo.

	type "!bat_outputfile!"
	
	echo.
	echo.
	echo.type "!bat_outputfile!"

:REPORTCOUNTS_END
!bat_poplog! [RETURN !bat_batchfile!:REPORTCOUNTS] [bat_returncocde=!bat_returncode!]
!bat_log!
!bat_return!





:CLEANUP
!bat_pushlog! [CALL !bat_batchfile!:CLEANUP] %*

	rem del /q "!bat_outputfile!"

:CLEANUP_END
!bat_poplog! [RETURN !bat_batchfile!:CLEANUP] [bat_returncocde=!bat_returncode!]
!bat_log!
!bat_return!




:HELP
	echo.%~0	Batch Script
	echo.
	echo.	Usage: %~0 "<target directory>" [<first camera> <last camera>]
	echo.
	echo.	Lists the results for each camera.
	echo.
	echo.	Example:
	echo.	   %~0 "C:\CAMS\Temp\Coincidence\2014_10_19"
	echo.	   %~0 "C:\CAMS\Temp\Coincidence\2014_10_19" 701 736


goto :EOF




:DONE
	!bat_popecho! goto !bat_batchfile!:DONE [!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	exit /b !bat_returncode!


