  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2011:
		
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_logfile=!bat_logdir!\CreateCameraListFile.bat.log
	

	rem call :READPARAMS

	if "%~1" equ "" (
		goto :HELP
	)

	rem Get the detectdir and the detect file name from 
	rem "c:\cams\ArchivedFiles\2014_11_17_01_58_37\FTP_detectinfo_0999_2014_11_17_01_58_37.txt'
	rem
	rem bat_detectdir will be: c:\cams\ArchivedFiles\2014_11_17_01_58_37
	rem bat_detectfilename=FTP_detectinfo_0999_2014_11_17_01_58_37.txt
	rem
	set bat_detectfilefull=%~1
	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_detectfilefull!"
	set bat_detectdir=!bat_retval1!
	set bat_detectfilename=!bat_retval2!
	
	rem Get the base dir: 
	rem bat_basedir=c:\cams
	rem
	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_retval1!"
	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_retval1!"
	set bat_basedir=!bat_retval1!
	
	set bat_cameralist_file_name=SortDetect_CameraList.txt
	set bat_cameralist_dir=!bat_detectdir!
	set bat_cameralist_file=!bat_cameralist_dir!\!bat_cameralist_file_name!

	goto :MAIN %*
goto :DONE





	rem Loop to read the detect file.
	rem The goal is to extract from the detect file:
	rem  bat_ffdir, bat_caldir, bat_calfilename, bat_camera
:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] "!bat_detectfile_temp!" [%*]
	set bat_retval=success
	set bat_returncode=0

	call :GETCAMERAFROMDETECT

:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [!bat_retval!, bat_camera_list=!bat_camera_list!]
!bat_log!
goto :DONE






:GETCAMERAFROMDETECT
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERAFROMDETECT] %*

	set /a bat_archivedmeteorcount=0
	set bat_camera_temp=
	set bat_camera_prev=
	set bat_camera_list=
	set /a bat_camera_count=0
	
	if exist "!bat_cameralist_file!" (
		del /q "!bat_cameralist_file!"
	)
	
	rem Iterate through the list of FF*.bin files in the detect file and create a text file that
	rem lists unique camera numbers. 
	!bat_echolog! ********** Creating Camera List file "!bat_cameralist_file_name!" IN "!bat_cameralist_dir!"
	!bat_pushlog! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".bin" "!bat_detectfilefull!"][sort`^) do ^(
	for               /f "usebackq tokens=* skip=2" %%a in  (`find /i ".bin" "!bat_detectfilefull!"^|sort`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_temp=%%~nxa

		set bat_camera_temp=!bat_temp:~2,3!

		if /i "!bat_camera_prev!" neq "!bat_camera_temp!" (
			if not defined bat_camera_list (
				!bat_log! 'a        ADDING "!bat_camera_temp!" TO CAMERA LIST: "!bat_cameralist_file_name!": !bat_temp!
				set bat_camera_list=0!bat_camera_temp!
				set bat_camera_prev=!bat_camera_temp!
				set /a bat_camera_count+=1
				echo !bat_camera_temp!>>"!bat_cameralist_file!"
			) else (
				call :CHECK_GCFC "!bat_camera_temp!"
				if not defined bat_GCFC_found (
					!bat_log! 'c        ADDING "!bat_camera_temp!" TO CAMERA LIST: "!bat_cameralist_file_name!": !bat_temp!
					set bat_camera_list=!bat_camera_list!0!bat_camera_temp!
					set bat_camera_prev=!bat_camera_temp!
					set /a bat_camera_count+=1
					echo !bat_camera_temp!>>"!bat_cameralist_file!"
				)
			)

			if not defined bat_camera (
				set bat_camera=!bat_camera_temp!
				!bat_log! 'b    set bat_camera=!bat_camera_temp!
			)
		)
	)
	!bat_poplog! ^)
	
	!bat_log! Sorting camera list in "!bat_cameralist_file!" - before...
	!bat_logexeclog! type "!bat_cameralist_file!"

	!bat_log!
	!bat_logexeclog! sort "!bat_cameralist_file!" /output "!bat_cameralist_file!"
	!bat_log!
	!bat_log! Sorting camera list in "!bat_cameralist_file!" - after...
	!bat_logexeclog! type "!bat_cameralist_file!"
	
	set bat_camera_list=
	call :GETCAMERALIST
	
:GETCAMERAFROMDETECT_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERAFROMDETECT] [bat_camera=!bat_camera!, bat_camera_list=!bat_camera_list!, bat_archivedmeteorcount=!bat_archivedmeteorcount!]
!bat_log!
!bat_return!





:CHECK_GCFC
!bat_pushlog! [CALL !bat_batchfile!:CHECK_GCFC] [%*]
	set bat_GCFC_found=
	
	find /i "%~1" "!bat_cameralist_file!">nul
	if %errorlevel% equ 0 (
		set bat_GCFC_found=true
	)
	
:CHECK_GCFC_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_GCFC] [%~1, bat_GCFC_found=!bat_GCFC_found!]
!bat_log!
!bat_return!






:CREATECAMERALISTFILE
!bat_pushlog! [CALL !bat_batchfile!:CREATECAMERALISTFILE] [%*]

	find /i ".bin" "!bat_detectfilefull!"|sort>"!bat_detectdir!\temp.txt"
	

:CREATECAMERALISTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:CREATECAMERALISTFILE] [%~1, bat_GCFC_found=!bat_GCFC_found!]
!bat_log!
!bat_return!











	rem Gets the camera list from the SortDetect_CameraList.txt file in the ArchivedFiles dir.
	rem The full path to the SortDetect_CameraList.txt file is passed as argv1.
	rem Returns: bat_camera_list
:GETCAMERALIST [in] "!bat_archivedfilesdir!"
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERALIST] %*

	set bat_camera_list=
	set bat_camera_temp=
	
	if not exist "!bat_cameralist_file!" (
		!bat_log! '    ERROR - not exist: "!bat_cameralist_file!"
		goto :GETCAMERALIST_END
	)

	for /f "usebackq tokens=*" %%a in (`type "!bat_cameralist_file!"`) do (
		if not defined bat_camera_list (
			set bat_camera_list=0!%%a
			!bat_logexeclog! set bat_camera_temp=%%a
		) else (
			set bat_camera_list=!bat_camera_list!0%%a
		)
	)
	
	if defined bat_camera_temp (
		!bat_logexeclog! set bat_camera=!bat_camera_temp!
	)

:GETCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERALIST] [bat_camera_list=!bat_camera_list!, bat_camera=!bat_camera!]
!bat_log!
!bat_return!












:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0  "^<detect file^>"
	echo.
	echo.Creates the "SortDetect_CameraList.txt" file based on the specified detect file.  
	echo.The "SortDetect_CameraList.txt" file is similar to the GCFC.log in the 
	echo.CapturedFiles dir except that the "SortDetect_CameraList.txt" file contains a list
	echo.of unique cameras that are only found in the detect file, as opposed to a complete
	echo.camera list for the capture session.  In other words, only those cameras that have
	echo.detections. 
	echo.
	echo.There may be a need to accommodate situations where there are no entries in the file.
	echo.
	echo.Results:
	echo.   SortDetect_CameraList.txt
	echo.
exit /b -99



:DONE
	!bat_poplog! :DONE with %~f0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!

	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
		SET bat_camera_list=%bat_cameralist%
	) ELSE ( echo.%bat_retval%)

exit /b !bat_returncode!