  @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.

goto :SETUP
	
	
:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	!bat_CALL! "!bat_exedir!\ReadParams.bat"

	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	SET bat_returncode=0
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_mergedetectfiles_ini_file=!bat_exedir!\MergeDetectFiles.ini
	

	set bat_returncode=0
	call :PARSEARGS %*

	%bat_echolog% Version: !bat_vers!
	!bat_push!
goto :MAIN

	
:PARSEARGS [in=%*]
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*


	!bat_logexeclog! set bat_detectfile_full=%~1
	!bat_logexeclog! set bat_detectfile_name=%~nx1


!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [bat_detectfile_full=!bat_detectfile_full!]
!bat_log!
!return!


:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	set bat_returncode=0
	
	if "!bat_detectfile_full!" equ "" (
		!bat_echolog! No detect file specified on the command line. 
		!bat_echolog!
		!bat_echolog! Try to determine why autocams couldn't find the detect file
		!bat_echolog! in the "!bat_archivedfilesdir!" directory.  
		!bat_echolog!
		set bat_returncode=1
		goto :MAIN_END
	)

	call :MERGEDETECT %*

:MAIN_END
!bat_poplog! [END !bat_batchfile!:MAIN] []
!bat_log! goto :DONE
goto :DONE



:MERGEDETECT
!bat_pushecho! [CALL !bat_batchfile!:MERGEDETECT] []
	set bat_returncode=0
	call :GETMETEORCOUNT %*
	call :REBUILDHEADER %*
!bat_popecho! [RETURN !bat_batchfile!:MERGEDETECT] []
!bat_echolog!
%bat_return%






	rem Save the meteor count into bat_count	
:GETMETEORCOUNT [out=bat_count]
!bat_pushecho! [CALL !bat_batchfile!:GETMETEORCOUNT] %*
	if not exist "!bat_detectfile_full!" (
		!bat_echolog! '    ERROR - file not found: "!bat_detectfile_full!"
		set bat_returncode=1
		goto :ABORT
	)
	
	
	set bat_count=
	set bat_countsrc=

	!bat_pushlog! '    for /f "usebackq tokens=1-4" ..a in ^(`find /i /c ".bin" "!bat_detectfile_full!"`^) do ^(
	for                    /f "usebackq tokens=1-4" %%a in  (`find /i /c ".bin" "!bat_detectfile_full!"`) do (
		!bat_log! '    set bat_count=%%c
		               set bat_count=%%c
	)
	!bat_poplog! ^)


	!bat_pushlog! '    for /f "usebackq tokens=*" ..a in ^(`find /i "Meteor Count" "!bat_detectfile_full!"`^) do ^(
	for                    /f "usebackq tokens=*" %%a in  (`find /i "Meteor Count" "!bat_detectfile_full!"`) do (
		!bat_log! '    set bat_countsrc=%%a
		               set bat_countsrc=%%a
	)
	!bat_poplog! ^)


	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
	set bat_countdest=Meteor Count = !bat_count!

	!bat_echolog! '    Before Fix: !bat_countsrc!

:GETMETEORCOUNT_END
!bat_popecho! [RETURN !bat_batchfile!:GETMETEORCOUNT] [Actual Meteor Count: !bat_count!,
!bat_echolog! '                                     Before Fix: !bat_countsrc!]
!bat_echolog!
%bat_return%



	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
!bat_pushecho!! [CALL !bat_batchfile!:REBUILDHEADER] %*

	set bat_findstr_c=!bat_countsrc!

	set bat_replstr_c=!bat_countdest!

	!bat_logexeclog! call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_detectfile_full!" "!bat_findstr_c!" "!bat_replstr_c!"

	echo.
	echo.
	echo.
	!bat_pushlog! '    for /f "usebackq tokens=* skip=2" ..a in ^(`find /i "Meteor Count" "!bat_detectfile_full!"`^) do ^(
	for                    /f "usebackq tokens=* skip=2" %%a in  (`find /i "Meteor Count" "!bat_detectfile_full!"`) do (
		!bat_echolog! Verify after fix:  %%a
	)
	!bat_poplog! ^)
	echo.
	echo.

!bat_popecho! [RETURN !bat_batchfile!:REBUILDHEADER] [see output above from the command: notepad "!bat_detectfile_full!"]
!bat_echolog!
%bat_return%




:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "{detectfile_fullpath}" 
	echo.
	echo.Gets the true meteor count by scanning the given detect file for instances of
	echo.".bin" and replaces the first line of the file with that value.
	echo.
	echo.This should work for both ArchivedFiles and ConfirmedFiles, as well as any
	echo.detect file in any other directory. 
	echo.
exit /b -99

Needs:
	- 
	
:ABORT
	!bat_popecho! [GOTO !bat_batchfile:ABORT!] [ABORTING bat_returncode=!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
	if not defined bat_autonomous (
		pause
	)
exit /b !bat_returncode!

:DONE
	rem call :SAVECONFIG
	!bat_echolog!
	!bat_popecho! [GOTO !bat_batchfile!:DONE] Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!