@echo off
setlocal enableextensions enabledelayedexpansion

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

	set bat_batchfile_temp=!bat_batchfile!
	set bat_batchfile=%~nx0

	set bat_GCFC_tempfile=%~1\GCFC.log

	rem Gets the camera list from the GCFC.log file in the CapturedFiles dir.
	rem The full path to the GCFC.log file is passed as argv1.
	rem Returns: bat_camera_list
:GETCAMERALIST [in] "!bat_capturedfilesdir!"
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERALIST] %*

	set bat_camera_list=
	set bat_camera_first=
	set bat_camera_last=

	set bat_camera_temp=


	set /a bat_CAPTURE.number.of.cameras=0
	for /f "usebackq tokens=*" %%a in ("!bat_GCFC_tempfile!") do (
		!bat_log! %%a
		
		if /i "%%a" neq "" (
			set /a bat_CAPTURE.number.of.cameras+=1
			if not defined bat_camera_list (
				!bat_logexeclog! set bat_camera_list=0%%a
				!bat_logexeclog! set bat_camera_first=%%a
				!bat_logexeclog! set bat_camera_last=%%a
				!bat_logexeclog! set bat_camera_temp=%%a
			) else (
				!bat_logexeclog! set bat_camera_list=!bat_camera_list!0%%a
				!bat_logexeclog! set bat_camera_last=%%a
			)
		)
	)
	
	if !bat_CAPTURE.number.of.cameras! GTR 1 (
		!bat_logexeclog! set bat_camera_list=0!bat_camera_first!0!bat_camera_last!
	) ELSE (
		!bat_logexeclog! set bat_camera_list=0!bat_camera_first!
	)

	if defined bat_camera_temp (
		!bat_logexeclog! set bat_camera=!bat_camera_temp!
	)


:GETCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERALIST] 
!bat_log! `                           [bat_camera_list=!bat_camera_list!, 
!bat_log! `                            bat_camera=!bat_camera!, 
!bat_log! `                            bat_camera_first=!bat_camera_first!,
!bat_log! `                            bat_camera_last=!bat_camera_last!,
!bat_log! `                            file="!bat_GCFC_tempfile!"]
set bat_batchfile=!bat_batchfile_temp!
set bat_batchfile_temp=
!bat_log!

ENDLOCAL & (
	SET bat_camera_list=%bat_camera_list%
	set bat_camera=%bat_camera%
	set bat_camera_first=%bat_camera_first%
	set bat_camera_last=%bat_camera_last%
)
!bat_return!




:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.Usage: %~nx0 "<dir>"
	echo.
	echo.Returns:
	echo.     bat_camera_list        - Contains a list of camera numbers in this format:
	echo.                              09980999
	echo.     bat_camera
	echo.     bat_camera_first
	echo.     bat_camera_last
	echo.
	echo.The list of cameras actually comes from the GCFC.log file in the CapturedFiles dir.
	echo.
	echo.To build the GCFC.log file, run: 
	echo.
	
exit /b -99
