@echo off
setlocal enableextensions enabledelayedexpansion


:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	!bat_call! "!bat_exedir!\localize_GETDATE2_!bat_AUTOCAMS.locale!.bat"
	set bat_date=!bat_currdate!&	rem set bat_date=%date:~-10%
	if "%~1" neq "" (
		set bat_date=%~1
	)

	echo.
	echo.!bat_date!|find /i "/" 1>2>nul:
	if !errorlevel! NEQ 0 (goto :DONE)

	for /f "delims=/ tokens=1-3" %%a in ("!bat_date!") do (
		set bat_mo=0%%a
		set bat_mo=!bat_mo:~-2!
		set bat_da=0%%b
		set bat_da=!bat_da:~-2!
		set bat_year=20%%c
		set bat_year=!bat_year:~-4!
	)

	call :date2jdate bat_jd !bat_year! !bat_mo! !bat_da!
	call :jdate2date !bat_jd! bat_year bat_mo bat_da
	
	set bat_date=!bat_year!_!bat_mo!_!bat_da!
	set bat_datemin=!bat_year!!bat_mo!!bat_da!
	
:PARSETIME
	!bat_call! "!bat_exedir!\localize_PARSETIME1_!bat_AUTOCAMS.locale!.bat"
	set ftp_hmsd=!ftp_hr!!ftp_mi!!ftp_se!!ftp_sed!

	set /a bat_midnightsecs=86400


:GETOUTFILE
	set bat_outfile=
:GETOUTFILE2
	if "%~1" equ "" (
		goto :MAIN
	)

	echo.%1|find /i "/out">nul:
	if %errorlevel% equ 0 goto :GETOUTFILE3
	shift
	goto :GETOUTFILE2
:GETOUTFILE3
	set bat_outfile=%~2
	set bat_outfile
	shift
	goto :GETOUTFILE2
goto :MAIN




:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*
rem	echo.for /f "usebackq tokens=*" ..b in ^(`dir "!bat_exedir!\CapturedFiles\!bat_date!*" /b /ad 2^}nul`^) do ^(
	for      /f "usebackq tokens=*" %%b in (`dir "!bat_exedir!\CapturedFiles\!bat_date!*" /b /ad 2^>nul`) do (
		echo.
		echo --------!bat_exedir!\CapturedFiles\%%b--------
		set /a bat_count=0
rem		echo.for /f "usebackq tokens=*" ..a in ^(`dir "!bat_exedir!\CapturedFiles\%%b\ff???_!bat_datemin!_*.bin" /s/b /a-d 2^}nul`^) do ...
		 for     /f "usebackq tokens=*" %%a in  (`dir "!bat_exedir!\CapturedFiles\%%b\ff???_!bat_datemin!_*.bin" /s/b /a-d 2^>nul` ) do (
			set /a bat_count+=1
			if defined bat_outfile (
				echo %%a>>"!bat_outfile!"
			)
			set bat_lastfilename=%%a
			if !bat_count! equ 1 (
				set bat_firstfilename=%%a

				rem Trim trailing backslash using ::
				set bat_temp=%%~dpa::
				set bat_savepath=!bat_temp:\::=!
				set bat_savepath=!bat_savepath:::=!
			)
		)&	rem end for /f....

		if !bat_count! neq 0 (
rem			set bat_savefirst=!bat_firstfilename!
rem			set bat_savelast=!bat_lastfilename!
			echo Path:       "!bat_savepath!"
			echo First File: "!bat_firstfilename!"
			echo Last File:  "!bat_lastfilename!"
			echo Count:      !bat_count!
		) else (
			echo Target dir not found: ".\CapturedFiles\!bat_date!_*"
		)
		title Last file="!bat_savelast!"
	)
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [bat_count=!bat_count!,
!bat_log! `                                 bat_firstfilename=!bat_firstfilename!,
!bat_log! `                                 bat_lastfilename=!bat_lastfilename!]
!bat_log!
exit /b



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
!bat_call! "!bat_exedir!\Date2JDate.bat" %1 %2 %3 %4
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	!bat_call! "!bat_exedir!\JDate2Date.bat"  %1 %2 %3 %4
EXIT /b 0




:HELP
    echo     %~nx0&	rem batch file name
    echo.
    echo     Usage: %~nx0 [date] [/out outfile] [/?]
    echo.
    echo.     This script outputs a summary of the files in the matching
    echo.     CapturedFiles directory.  
    echo.
    echo.     This is useful in determing quickly if the capture failed anytime
    echo.     during the session before sunrise.
    echo.
    echo.     If the 'date' parameter is missing, it uses the current
    echo.     date. The specified date must be in the format where the 
    echo.     right-most 10 characters are MM/DD/YYYY, where the MM and DD
    echo.     use zero-leading values for numbers 1-9 (e.g. 01, 02, etc.). 
    echo.
    echo.     /out outfile - Optional - specifies the optional output file name.
    echo.                    If this is used, all the file names are output
    echo.                    to the specified file in a kind of "verbose" mode.
	echo.
    echo.     Example:
    echo.       %~nx0 09/15/2011 
    echo.
    echo.       Path:       "C:\cam213\CAMS\CapturedFiles\2011_09_15_02_30_18"
    echo.       First File: "C:\cam213\CAMS\CapturedFiles\2011_09_15_02_30_18\FF213_20110915_030121_737_0056064.bin"
    echo.       Last File:  "C:\cam213\CAMS\CapturedFiles\2011_09_15_02_30_18\FF213_20110915_130126_651_1100288.bin"
    echo.       Count:      345
	echo.
    echo.
EXIT /b -99


:DONE
echo.~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
