@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*


:SETUP
	call "%~dp0AutoCams.setup.bat" "%~f0"
	call "%~dp0indent_setup.bat"
	
	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=
	)

	if not defined bat_LOCALIZE.locale (
		call "!bat_exedir!\ReadParams.bat"
	)


	!bat_log!
	!bat_log! =============================================================
	!bat_log! [%date% %time%] - Version: [!bat_vers! - %~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

rem determing how many letters are used for the weekday (Thu = 3, Do = 2)
rem for Thu : weeksearch=www and n=3, for Do : weeksearch = ww and n=2

	if "%~1" equ "" (
		!bat_echolog!
		!bat_echolog! `    !bat_batchfile!: ERROR - no cams date specified.
		!bat_echolog!
		exit /b 1
	)
	
	set bat_theChar=w

		set bat_i=-1
		set /a bat_week_len=0&	rem Number of characters in the weekday from the format.date value.
		set bat_weeksearch=
goto :ENDLINE
:NEXTCHAR
		set /A bat_i+=1
		set bat_c=!bat_LOCALIZE.format.date:~%bat_i%,1!

		if "!bat_c!" == "" (goto :ENDLINE)

		if !bat_c! == !bat_theChar! (
			set /A bat_week_len+=1
			set bat_weeksearch=!bat_weeksearch!w
		)
	goto :NEXTCHAR

:ENDLINE
		rem echo %n% chars found
		rem echo bat_weeksearch : %bat_weeksearch%


	set bat_weeksearch=
	set /a bat_week_len=0&	rem Number of characters in the weekday from the format.date value.

		REM This next statement splits the format.date string into two strings
		REM at the point where there is a space.  The bat_rightstr does not
		REM include the space.
	set bat_rightstr=!bat_LOCALIZE.format.date:* =!
	
		REM If there are no spaces in the format.date string, then the search
		REM failed, which results in bat_rightstr the same value as format.date string.
		REM In that case, we're done and there isn't anything to do with the 
		REM format.date string. Otherwise, we will use that string to get 
		REM the weekday string
	if "!bat_rightstr!" NEQ "!bat_LOCALIZE.format.date!" (

        set bat_weeksearch=!bat_LOCALIZE.format.date: %bat_rightstr%=!

		if "!bat_weeksearch!" NEQ "" (
			for /L %%a in (0,1,8192) do (
				if "!bat_weeksearch:~%%a,1!" NEQ "" (
					set /a bat_week_len+=1
				)
			)
		)
	)

		REM swap the variables if format has the "www" after the date portion
	if /i "!bat_rightstr!:~0,1" equ "w" (
		set bat_tempstr=!bat_weeksearch!
		set bat_weeksearch=!bat_rightstr!
		set bat_rightstr=!bat_tempstr!
		set bat_tempstr=
	)
!bat_echolog! bat_weeksearch=!bat_weeksearch!, bat_week_len=!bat_week_len!
rem end of adjusted code bat_weeksearch



	if /i "%~1" neq "" (

		REM If you get here, a date was passed to the program without the weekday stuff.
		REM In that case, we need to strip all the W's from the format.date string to
		REM make it compatible with the PARSEDATE code. 

		set bat_date_parameter=%~1
		set bat_other_date=true

			rem If there is a manually entered date, then strip the weekday parsing from the format.date string.
		echo.!bat_LOCALIZE.format.date!|find /i "!bat_weeksearch! ">nul:
		if !errorlevel! equ 0 (
			!bat_logexec! set bat_LOCALIZE.format.date=!bat_LOCALIZE.format.date:%bat_weeksearch% =!
		)
		
		
		echo.!bat_LOCALIZE.format.date!|find /i " !bat_weeksearch!">nul:
		if !errorlevel! equ 0 (
			!bat_logexec! set bat_LOCALIZE.format.date=!bat_LOCALIZE.format.date: %bat_weeksearch%=!
		)

	)

rem echo.format.date=!bat_LOCALIZE.format.date!
	call :PARSEDATE

goto :DONE



   rem When run on 2013_10_13, it should result in:
   rem    ftp_da=03
   rem    ftp_mo=10
   rem    ftp_wmdy=Thu 10/03/2013
   rem    ftp_year=2013

:PARSEDATE
!bat_pushlog! [CALL !bat_batchfile!:PARSEDATE] %*

	SET ftp_wmdy=
	set ftp_year=
	set ftp_mo=
	set ftp_da=
	set bat_twilight_searchstr=

	set ftp_wmdy=!bat_date_parameter!
	set bat_date_temp=!bat_date_parameter!

	if not defined bat_LOCALIZE.delimiter.date (
		!bat_echolog!
		!bat_echolog! !bat_batchfile!:PARSEDATE    WARNING - Missing bat_LOCALIZE.delimiter.date from autocams.params.ini.  Using the default date delimiter as "/".
		!bat_echolog!
		set bat_LOCALIZE.delimiter.date=/
	)


	
	call :NON_WMIC


%bat_COMMENT_BEGIN%	
	if defined bat_other_date (
		call :NON_WMIC
	) else (
		call :USING_WMIC
	)


	if defined ftp_wmdy (
		!bat_log! Using WMIC.ftp_wmdy=!ftp_wmdy!


		set ftp_year=!ftp_wmdy:~0,4!
		set   ftp_mo=!ftp_wmdy:~4,2!
		set   ftp_da=!ftp_wmdy:~6,2!

		
		!bat_logexeclog! set bat_twilight_searchstr=!bat_date_temp:~-10!
	) else (
		call :NON_WMIC
	)
%bat_COMMENT_END%

	if "!ftp_mo!" LSS "10" (
		set /a ftp_mo2=!ftp_mo:~-1!
	) else (
		set ftp_mo2=!ftp_mo!
	)
	if "!ftp_da!" LSS "10" (
		set /a ftp_da2=!ftp_da:~-1!
	) else (
		set ftp_da2=!ftp_da!
	)


:PARSEDATE_END
!bat_pop!
!bat_log! [RETURN !bat_batchfile!:PARSEDATE] [ftp_wmdy=!ftp_wmdy!, ftp_year=!ftp_year!, ftp_mo=!ftp_mo!, ftp_da=!ftp_da!, bat_twilight_searchstr=!bat_twilight_searchstr!]
!bat_log!
!bat_return!




:NON_WMIC

		set ftp_da=!bat_date_parameter:~-2!
		set ftp_mo=!bat_date_parameter:~5,2!
		set ftp_year=!bat_date_parameter:~0,4!
		
		rem ftp_LocalDate is the date format without the "w"s
		set ftp_LocalDate=!bat_LOCALIZE.format.date:w=!
		set ftp_LocalDate=!ftp_LocalDate: =!
		
		
			rem This next two lines normalize the date to Y2K 4 digit yyyy format. 
			rem If the ftp_year value is already something like 1974, then it becomes first
			rem 201974.  Then it is truncated to 1974.  Otherwise, if the ftp_year is 
			rem something like 16, then it is converted to 2016.
		set ftp_year=20!ftp_year!
		set ftp_year=!ftp_year:~-4!
		
		set ftp_mo=0!ftp_mo!
		set ftp_mo=!ftp_mo:~-2!
		set ftp_mo2=!ftp_mo!
		if "!ftp_mo!" LSS "10" (
			set /a ftp_mo2=!ftp_mo:~-1!
		)
		
		set ftp_da=0!ftp_da!
		set ftp_da=!ftp_da:~-2!
		set ftp_da2=!ftp_da!
		if "!ftp_da!" LSS "10" (
			set /a ftp_da2=!ftp_da:~-1!
		)

		for /L %%a in (0,1,10) do (
			if /i "!ftp_LocalDate:~%%a,2!" == "dd" (set ftp_LocalDate=!ftp_LocalDate:dd=%ftp_da%!)
			if /i "!ftp_LocalDate:~%%a,2!" == "mm" (set ftp_LocalDate=!ftp_LocalDate:mm=%ftp_mo%!)
			if /i "!ftp_LocalDate:~%%a,4!" == "yyyy" (set ftp_LocalDate=!ftp_LocalDate:yyyy=%ftp_year%!)
		)
		
rem		set ftp_LocalDate

:NON_WMIC
!bat_return!



:USING_WMIC
	set ftp_wmdy=
		REM first attempt to get the date using the wmic way.
	for /f "usebackq skip=1 tokens=*" %%a in  (`call WMIC OS GET LocalDateTime`) do (
		if "%%a" gtr "0" (
			!bat_logexeclog! set ftp_wmdy=%%a
		)
	)


:USING_WMIC_END
!bat_return!




:HELP
	echo.Usage: call "%~dpnx0" [cams date]
	echo.
	echo.Parses the cams date [yyyy_mm_dd] and separates the
	echo.values into separate year, month, and day variables and 
	echo.also returns a value of the date in the user's locale so
	echo.that the presentation of the date value can be displayed 
	echo.according to the user's locale settings.
	echo.
	echo.Returns:
	echo.  environment variables using the ENDLOCAL command:
	echo.	ftp_year                 The 4 digit year with leading zeros
	echo.
	echo.	ftp_mo                   The two digit month with leading zeros
	echo.
	echo.	ftp_mo2                  Numeric month value [no leading zero]
	echo.
	echo.	ftp_da                   Two digit day with leading zeros
	echo.
	echo.	ftp_da2                  Numeric day value [no leading zero]
	echo.
	echo.	ftp_LocalDate            e.g. 12/25/2014 in en-US and 2014/12/25 in nl-BE
	echo.
	echo.The returned date is localized current locale format 
	ecgi.where the local date is returned according to: bat_LOCALIZE.format.date
	echo.
	echo.Example:
	echo.  If the date is October 5, 2013, this routine should result with:
	echo.    ftp_year=2013
	echo.    ftp_mo=10
	echo.    ftp_da=05
	echo.    ftp_LocalDate=10/13/2013
	echo.
	echo.This routine does not need to be modified for each locale, since it was written in a way to
	echo.avoid that requirement.
	echo.
	echo.The trick is in the construct of the ENDLOCAL command, where it passes
	echo.back variables that are local to this routine.
	echo.




:DONE
	!bat_pop!
	!bat_log! [!date!, !time!] !bat_batchfile!:DONE] %~dpnx0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!


	rem Note: It isn't necessary to return the ftp_wmdy value
	ENDLOCAL & (
		SET ftp_wmdy=%ftp_wmdy%
		set ftp_year=%ftp_year%
		set ftp_mo=%ftp_mo%
		set ftp_mo2=%ftp_mo2%
		set ftp_da=%ftp_da%
		set ftp_da2=%ftp_da2%
		set ftp_LocalDate=%ftp_LocalDate%
	)

	REM Display the output.  Once you get this working, REM out this line
	rem SET ftp_

exit /b 0
