  @echo off
setlocal enableextensions enabledelayedexpansion


:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2015:
		
	
:SETUP

	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"
	call "!bat_exedir!\ReadConfig.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	call :GETARGS %*
	
	call :MAIN %*
goto :DONE





:GETARGS
!bat_pushecho! [CALL !bat_batchfile!:GETARGS] %*

	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!
rem set bat_batchfile=%~nx0

	set bat_captureddate=%~2
	set bat_capturedtime=%~3
	set bat_captureddatetime=!bat_captureddate!_!bat_capturedtime!
	
	set bat_submissionfilesdir=%~4
	
	set bat_camera=%~5
	
	set bat_anonymous=%~6

	rem SET bat_ThisScriptsDirectory=%~dp0
	!bat_logexec! SET bat_PowerShellScriptPath=!bat_exedir!\emailCoordinators.ps1

:GETARGS_END
!bat_popecho! [RETURN !bat_batchfile!:GETARGS_END] [bat_PowerShellScriptPath=!bat_PowerShellScriptPath!,
!bat_echolog! `                                      bat_exedir=1=!bat_exedir!,
!bat_echolog! `                                      bat_captureddatetime=!bat_captureddatetime!,
!bat_echolog! `                                      bat_captureddate=2=!bat_captureddate!,
!bat_echolog! `                                      bat_capturedtime=3=!bat_capturedtime!
!bat_echolog! `                                      bat_submissionfilesdir=4=!bat_submissionfilesdir!
!bat_echolog! `                                      bat_camera=5=!bat_camera!,
!bat_echolog! `                                      bat_anonymous=6=!bat_anonymous!
!bat_echolog!
!bat_return!



:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] %*
!bat_push!

	set bat_returncode=0
	
	call :GETDETECTFILE
	set bat_returncode=!errorlevel!
	!bat_echolog! ..................!bat_returncode!
	if /i "!bat_returncode!" neq "0" (
		!bat_echolog! ERROR - [!bat_returncode!] GETDETECTFILE failed 
		goto :MAIN_END
	)
	
	call :MAILCOORDINATOR 
	if "!errorlevel!" neq 0 (
		!bat_echolog! PowerShell script failed: "%PowerShellScriptPath%"
		goto :MAIN_END
	)

:MAIN_END
!bat_pop!
!bat_pop!
!bat_popecho! [END !bat_batchfile!:MAIN_END] [!date! !time! - exit /b !bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
exit /b !bat_returncode!



:MAILCOORDINATOR
!bat_pushecho! [CALL !bat_batchfile!:MAILCOORDINATOR] %*

	set bat_returncode=0
	rem           PowerShell -NoProfile -ExecutionPolicy Bypass -File "%bat_PowerShellScriptPath%" "!bat_exedir!" "!bat_captureddatetime!" "!bat_submissionfilesdir!\!bat_camera!" "!bat_FTP_detectfile!" !bat_camera !bat_autonomous!
	!bat_logexec! PowerShell -NoProfile -ExecutionPolicy Bypass -File "%bat_PowerShellScriptPath%" "!bat_exedir!" "!bat_captureddatetime!" "!bat_submissionfilesdir!\!bat_camera!" "!bat_FTP_detectfile!" !bat_camera !bat_autonomous!
	set bat_returncode=!bat_logexec_returncode!
	
	


:MAILCOORDINATOR_END
!bat_popecho! [RETURN !bat_batchfile!:MAILCOORDINATOR] [bat_returncode=!bat_returncode!,
!bat_echolog! `                                      bat_ThisScriptsDirectory=!bat_ThisScriptsDirectory!,
!bat_echolog! `                                      bat_PowerShellScriptPath=!bat_PowerShellScriptPath!]
!bat_echolog!
!bat_return! !bat_returncode!




	rem This routine returns the name of the detect file as either the "_confirmed" version or the "_scanned" version. 
:GETDETECTFILE
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*

	set bat_returncode=0
	rem !bat_logexec! set bat_

	set bat_FTP_detectfile=
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_confirmed*.txt" /b`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_confirmed*.txt" /b`) do (
		!bat_logexeclog! set bat_FTP_detectfile=%%~nxa
	)
	
	if not defined bat_FTP_detectfile (
		!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir !bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_scanned*.txt /b`^) do ^(
		for               /f "usebackq tokens=*" %%a in (`dir !bat_submissionfilesdir!\!bat_camera!\EmailFiles\FTPdetectinfo_*_scanned*.txt /b`) do (
			!bat_logexeclog! set bat_FTP_detectfile=%%~nxa
		)
	)
	
	!bat_echolog! if not defined !bat_FTP_detectfile! ^(
	if               not defined  bat_FTP_detectfile (
		!bat_echolog! WARNING - missing detect file in "!bat_submissionfilesdir!\!bat_camera!\EmailFiles"
		set bat_returncode=1
		goto :GETDETECTFILE_END
	)

:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [bat_returncode=!bat_returncode!, bat_FTP_detectfile=!bat_FTP_detectfile!]
!bat_log!
!bat_return! /b !bat_returncode!





:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     Usage: %~nx0 "capture session datetime" "submission dir" "detect file"  [autonomous] [/?]
    echo.
    echo.    This script attempts to email the coordinator the submission zip file.  
    echo.
    echo.    Example:
    echo.       %~nx0 "2015_12_13" "01_00_49" "C:\CAMS\SubmissionFiles\2015_12_13_01_00_49\250" "250" autonomous "FTPdetectinfo_250_2015_12_13_01_00_49_confirmed.txt" 
    echo.
    echo.
EXIT /b 99
    
goto :DONE


:DONE
!bat_echolog! [%date% %time%] DONE !bat_batchfile! [!bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog!
echo Waiting...&!bat_WAIT!  10
exit /b !bat_returncode!
