@echo off
setlocal enabledelayedexpansion ENABLEEXTENSIONS
    if /I %errorlevel% NEQ 0 (
    	echo NOT SUPPORTED:"setlocal enabledelayedexpansion ENABLEEXTENSIONS"
    )

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2011:
		
	
:SETUP


	title %~0


	echo abc %*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	if /I {%1} == {/q} (set MD5.QUIET.MODE=true) else (set MD5.QUIET.MODE=false)



	set md5_1EB=1125899906842624
	set md5_1TB=1099511627776
	set md5_1GB=1073741824
	set md5_1MB=1048576
	set md5_1KB=1024

	set md5_timer_file="c:\timer_md5.txt"

		rem Set bat_str_math.enabled variable
	call :TEST_STR_MATH
set bat_str_math.enabled

	call :STARTTIMER

	set md5_use_timer_file=false
	if exist !md5_timer_file! set md5_use_timer_file=true

	set /a md5_timer_prev=0
	set tp_output=0

	set /a errorcount=0
	set /a successcount=0

	echo.
	echo     %~f0   version 2.0.1

	set savetime=%date:/=-%, %time::=-%.txt.log

	if exist "C:\md5check.err.log" (
		echo         Moving log file to create backup ("c:\md5check.err.log" to "C:\md5check.err_%savetime%")
		move /Y "c:\md5check.err.log" "C:\md5check.err_%savetime%"
	)

	if !md5.quiet.mode!==true goto :ENDFILELIST
	@echo     Files that will be checked in !CD! are:
	for /F "tokens=1,*" %%a in (md5.output.txt) do (
		call :LISTFILES "%%a" "%%b" "%%~zb"
	)
:ENDFILELIST

	if !md5.quiet.mode!==true goto :ENDPROMPT

	@echo.
	@echo     Note: It is safe to interrupt this process at any time.  Errors will be
	@echo           logged in "C:\md5check.err.log".
	@echo.
	@echo           Reading files and computing the hash - please be patient, this can 
	@echo           take several minutes for large files... (the caption bar will 
	@echo           display the size of the files it is working on)
	@echo.
:ENDPROMPT

	@echo.
	@echo     Starting...
	@echo.


	if not exist "md5.output.txt" (
		echo "md5.output.txt" does not exist in the following directory:
		echo !cd!
		goto :DONE
	)

	echo     "%cd%">c:\md5check.err.log
	echo     Errors on %date% %time%... >> c:\md5check.err.log

	set /a errorcount=0
	set /a successcount=0

	for /F "tokens=1,*" %%a in (md5.output.txt) do (
		call :test2 "%%a" "%%b" %%~zb
	)

	@echo.
	@echo.

	if !errorcount! neq 0 (
		echo     Successful: !successcount!		Failed: !errorcount!
		echo.
		echo     Successful: !successcount!		Failed: !errorcount!>>C:\md5check.err.log
		echo.>>C:\md5check.err.log
		type c:\md5check.err.log
	) else (
		echo     Successful: !successcount!		Failed: !errorcount!	ALL PASSED   in !CD!\md5.output.txt
		echo.
		echo     Successful: !successcount!		Failed: !errorcount!	ALL PASSED   in 

	!CD!\md5.output.txt>>C:\md5check.err.log
		echo.>>C:\md5check.err.log
		type c:\md5check.err.log
	)
goto DONE


:TEST2
  if NOT EXIST "%~2" (
        set /a errorcount+=1
        echo.
        echo     File not found:   FAILED  "%~2"
        echo.
        echo     [%date% %time%] File not found:   FAILED  "%~2" >> c:\md5check.err.log
  ) else (
      set md5_formatsize_output=%3
      call :FORMATSIZE %3 %2
      CALL :TIMERSTART
      md5 -c%~1 "%~2"
        if !errorlevel! NEQ 0 (
            set /a errorcount+=1
            echo.
            echo     %1  FAILED  "%~2"  [!md5_filesize_output!]	!tp_output!
            echo.
			CALL :TIMEREND %3
            echo     [%date% %time%] FAILED  "%~2"  [!md5_filesize_output!]	!tp_output!>> c:\md5check.err.log
        ) else (
            set /a successcount+=1
			CALL :TIMEREND %3
            echo     %1  PASSED  "%~2"  [!md5_filesize_output!]	!tp_output! 
        )
  )

goto :EOF





:LISTFILES
	if NOT EXIST "%~2" (
			@echo     "%~2" File not found..............
	) else (
		set md5_formatsize_output=%3
		call :FORMATSIZE %3 %2
		echo     !FILESTR!

	)
goto :EOF





:FORMATSIZE
    set md5_prev_filesize_ouput=!md5_filesize_output!
    
    set md5_filesize=%~1
    set md5_filesize_output=%~1 bytes

	if !bat_str_math.enabled! neq true (
		goto :FORMATSIZE_END
	)
	
    set md5_filesize_outputDecG=
    set md5_filesize_outputDecM=
    set md5_filesize_outputDecK=
    set md5_GB=
    set md5_KB=
    set md5_MB=
    set md5_remainderGB=
    set md5_remainderMB=
    set md5_GBfloat=
    set md5_MBfloat=
    set md5_KBfloat=
    set md5_temp1=
    set md5_temp2=

    
    set md5_temp1=!bat_retval!
    
    set md5_GB=0
    set md5_MB=0
    set md5_KB=0
   


	rem ***** GB *************
rem	echo if !md5_filesize! gEQ !md5_1GB! ^(
	if !md5_filesize! gEQ !md5_1GB! (
		call :DIV_GET_INT_REM !md5_filesize! !md5_1GB!
		set md5_GB=!bat_retval!
		set md5_remainderGB=!bat_retval1!
		set md5_filesize_outputDecG=!bat_retval2!
		if !md5_GB! NEQ 0 (goto :FORMATSIZE2)
	)
	
	
	rem ***** MB *************
rem	echo if !md5_filesize! gEQ !md5_1MB! ^(
	if !md5_filesize! gEQ !md5_1MB! (
		call :DIV_GET_INT_REM !md5_filesize! !md5_1MB!
		set md5_MB=!bat_retval!
		set md5_remainderMB=!bat_retval1!
		set md5_filesize_outputDecM=!bat_retval2!
		if !md5_MB! NEQ 0 (goto :FORMATSIZE2)
	)
	
	
	rem ***** KB *************
rem	echo if !md5_filesize! gEQ !md5_1KB! ^(
	if !md5_filesize! gEQ !md5_1KB! (
		call :DIV_GET_INT_REM !md5_filesize! !md5_1KB!
		set md5_KB=!bat_retval!
		set md5_remainderKB=!bat_retval1!
		set md5_filesize_outputDecK=!bat_retval2!
		goto :FORMATSIZE2
	)


:FORMATSIZE2

    if !md5_GB! NEQ 0 (
        set md5_filesize_output=!md5_GB!!md5_filesize_outputDecG! GB
    ) else (
        if !md5_MB! NEQ 0 (
            set md5_filesize_output=!md5_MB!!md5_filesize_outputDecM! MB
        ) else (
            if !md5_KB! NEQ 0 (
                set md5_filesize_output=!md5_KB!!md5_filesize_outputDecK! KB
            ) else (
            	set md5_filesize_output=!md5_filesize!  _B
            )
        )
    )


:FORMATSIZE_END
  set FILESTR="%~2" [!md5_filesize_output!]
  Title Reading %FILESTR%...  prev=!md5_prev_filesize_ouput!, !tp_output!

goto :EOF





:DIV_GET_INT_REM [in] LargeFloatingNumberator FloatingDenominator [out] bat_retval bat_retval1 bat_retval2
 rem echo.CALL [:DIV_GET_INT_REM] %*
	rem LargeFloatingNumber		16428249907
	rem FloatingDenominator		!md5_1GB!    [1073741824]
	rem bat_retval				15
	rem bat_retval1				1050221187.123456789
	rem bat_retval2				
	

		rem Let's say the number is 15.29999999998 GB and the Large is 16428249907
		rem and demoninator is md5_1GB.
rem echo call "str_math.bat" %~1 / %~2 
	call "str_math.bat" -command "[math]::round(%~1 / %~2,4)">nul:

	set md5_temp1=!bat_retval!&				rem returns md5_temp1=[15.299999998]
::echo a "str_math.bat" %~1 / %~2 =!md5_temp1!

	call :INT md5_temp2 !bat_retval!&		rem returns md5_temp2=[15]
::echo b :INT md5_temp2 !bat_retval!=!md5_temp2!

	call "str_math.bat" !md5_temp2! x %~2>nul:
::echo c "str_math.bat" !md5_temp2! x %~2=!bat_retval!

::echo d "str_math.bat" %~1 - !bat_retval!=
	call "str_math.bat" %~1 - !bat_retval!>nul:
::echo e                                   =!bat_retval!

	set bat_retval1=!bat_retval!&			rem 322122547
::echo f set bat_retval1=!bat_retval!

	call "str_math.bat" !md5_temp1! - !md5_temp2!>nul:
::echo g "str_math.bat" !md5_temp1! - !md5_temp2!=!bat_retval!
	call "str_math.bat" !bat_retval! + 0.0005>nul:
::echo g2 "str_math.bat" !bat_retval! + 0.0005 = !bat_retval!

	set bat_retval2=!bat_retval:~1,4!&			rem .2999999998
::echo h bat_retval2=bat_retval:~1,3=!bat_retval2!

	if not defined bat_retval2 (
		set bat_retval2=.000
	) else (
::echo i bat_retval2=!bat_retval2!
		set bat_retval2=!bat_retval2!000
		set bat_retval2=!bat_retval2:~0,4!
	)
	
	set bat_retval=!md5_temp2!&				rem 15
 rem echo.RETURN [:DIV_GET_INT_REM] [!bat_retval!, !bat_retval1!, !bat_retval2!]
 rem pause
goto :EOF


:INT [in] variable value
	rem Strip the decimal off a floating point number
	for /f "usebackq tokens=1,2 delims=.,-" %%a in ('%~2') do (
		set %~1=%%a
	)
goto :EOF


:TIMERSTART
	if !bat_str_math.enabled! neq true (goto :TIMERSTART_END)

	rem	echo !md5_timer_file!
	if exist !md5_timer_file! set md5_use_timer_file=true

	if !md5_use_timer_file! equ false (
		rem
	) else (
		for /F "usebackq" %%t in (!md5_timer_file!) do (
			set /a timer_first=%%t
		)
	)
:TIMERSTART_END
goto :EOF



:TIMEREND
	if !bat_str_math.enabled! neq true (goto :TIMEREND_END)

	if exist !md5_timer_file! set md5_use_timer_file=true
		set tp_output= 
	if !md5_use_timer_file! equ false (
		set tp_output= 
	) else (
		for /f "usebackq" %%t in (!md5_timer_file!) do (
			set /a timer_last=%%t
		)

		set /a timer_delta=!timer_last!-!timer_first!
		rem echo set /a timer_delta=!timer_last!-!timer_first!
		if !timer_delta! equ 0 set /a timer_delta=1
		rem echo !timer_delta!


		set tp_size1=%~1
		set tp_size2=            %~1b
		set /a tp_seconds=!timer_delta!

			rem get throughput as md5_temp1
		call "str_math.bat" -command "[math]::round(!tp_size1! / !tp_seconds!,0)">nul:
		set md5_temp1=!bat_retval!

		if !md5_temp1! gEQ !md5_1GB! (
			call "str_math.bat" -command "[math]::round(!md5_temp1! / 1GB,3)">nul:
			rem call "str_math.bat" !bat_retval! + 0.0005>nul:
			set bat_retval=!bat_retval:~0,-1!
				set tp_output=!bat_retval!  GB/!tp_seconds! sec
				goto :TIMEREND_END
			)


		if !md5_temp1! gEQ !md5_1MB! (
			call "str_math.bat" -command "[math]::round(!md5_temp1! / 1MB,3)">nul:
			rem call "str_math.bat" !bat_retval! + 0.0005>nul:
			set bat_retval=!bat_retval:~0,-1!
				set tp_output=!bat_retval!  MB/!tp_seconds! sec
				goto :TIMEREND_END
		)


		if !md5_temp1! gEQ !md5_1KB! (
			call "str_math.bat" -command "[math]::round(!md5_temp1! / 1KB,3)>nul:
			rem call "str_math.bat" !bat_retval! + 0.0005>nul:
			set bat_retval=!bat_retval:~0,-1!
				set tp_output=!bat_retval!  KB/!tp_seconds! sec
				goto :TIMEREND_END
		)

		set tp_output=!tp_size1!  _B/sec !tp_seconds!& rem  !tp_size1!, !md5_temp1!
		goto :TIMEREND_END
	)


:TIMEREND_END
goto :EOF


:STARTTIMER
	if !bat_str_math.enabled! neq true (goto :STARTTIMER_END)

	rem Check to see if timer is changing. If it is, there is a timer already running, so don't start a new one.
	set md5_test_timer_file=false
	if exist !md5_timer_file! set md5_test_timer_file=true
	if !md5_test_timer_file! equ false (
		start "timer.bat" /min timer "!md5_timer_file!" 3600
	) else (
		for /F "usebackq" %%t in (!md5_timer_file!) do (
			set /a timer_first=%%t
		)
		!bat_WAIT!  5
		for /F "usebackq" %%t in (!md5_timer_file!) do (
			set /a timer_last=%%t
		)
		if /i !timer_first! equ !timer_last! (
			start "timer.bat" /min timer "!md5_timer_file!" 3600
		)
		
	)

:STARTTIMER_END
goto :EOF




:TEST_STR_MATH
	call "str_math.bat" pi>nul: 2>&1
	if !errorlevel! equ 0 (
		set bat_str_math.enabled=true
	) else (
		set bat_str_math.enabled=false
	)
:goto :EOF




:HELP
@echo md5Check.bat
@echo.
@echo - This utility must be run from a command line.  
@echo - It must be run from the directory that contains all the files.
@echo - You must have write permission to C:\.
@echo - It requires md5.output.txt, md5.exe, and the files listed in 
@echo   md5.output.txt
@echo - It may require that timer.bat and wait.exe are in the path.
@echo.
@echo When you run this utility, it could take a long time (several 
@echo minutes) since it has to read each entire file to compute an 
@echo MD5 hash for it.  Each MD5 hash is a number that is computed 
@echo based on the contents of the file.  The md5.output.txt file 
@echo contains the computed hashes for the original files.  When you 
@echo run md5Check.bat, it will read each file in the list, compute 
@echo an MD5 hash number based on the current contents, and compare 
@echo that with the original hash in md5.output.txt.  If they are 
@echo not the same, it will output a "FAILED" message for that file 
@echo and then check the next file.  If the hashes are the same, it 
@echo produces a "PASSED" message and continues with the next.
@echo.
@echo The utility uses the md5.exe command line switch -c to check for a 
@echo matching hash as follows:
@echo      md5 -c94B855A8970CB16A323FDCB510618BE4  d534-s001.vmdk
@echo.
@echo Then the errorlevel is checked for 0=pass, 1=fail
@echo.
@echo For throughput information, the script calls the "timer" command. 
@echo The "timer" command may be a "timer.bat" script that is in the path.  
@echo There are two versions provided: 
@echo   1) timer_disabled.bat
@echo   2) timer_enabled.bat
@echo.
@echo If you want the timer enabled, copy timer_enabled.bat to timer.bat 
@echo to a directory that is in the path.  The default is that the timer 
@echo is disabled.  The timer_enabled.bat script calls the "wait.exe" 
@echo command, which should also be in the path if you enable the timer. 
@echo.
@echo This script outputs three (possibly four) files to C:\ as follows.  
@echo They remain there until you manually delete them:
@echo - md5check.err_^<date/time^>.txt.log
@echo - md5check.err.log
@echo - md5checkRebuildDirs.err.log
@echo - timer_md5.txt

goto :EXIT


:DONE

@echo.
@echo     FINISHED md5check.bat in !CD!.

:EXIT
title %cd%
