 @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


setlocal enableextensions enabledelayedexpansion

:CHECKHELP
echo :CHECKHELP %*
    	echo.%*|find /i "/?">nul:
    	if %errorlevel% equ 0 goto :HELP
    	echo.%*|find /i "/h">nul:
    	if %errorlevel% equ 0 goto :HELP
    	echo.%*|find /i "/help">nul:
    	if %errorlevel% equ 0 goto :HELP
goto :SETUP

	Flowchart:
		- Obtain the processed ".\ConfirmedFiles\<dirname>"
		- Create the target ".\SubmissionFiles\<dirname>" directory tree:
		  - EmailFiles
		  - BinFiles
		  - AviFiles
		- Copy the ".\ArchivedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_scanned.txt"
		- Copy the ".\ConfirmedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_confirmed.txt"
		- Copy the ".\ArchivedFiles\<dirname>\CameraTimeOffsets.txt" file 

		- Move the ".\ConfirmedFiles\<dirname>\*.bin" files to 
		  the ".\SubmissionFiles\<dirname>\BinFiles" directory.
		- Read the ".\SubmissionFiles\<dirname>\ftpdetectinfo.txt" file and 
		  get the following:
			- Meteor Count     from line number 1
			- FF  folder       from line number 5
			- CAL folder       from line number 6
			- calibration file from line number 14
			- camera number    from calibration file
	==============================================================		
	New changes 09/08/2011:
		x Add a " [date/time]\EmailFiles\Cal-[camera]" directory and place the calibration files there.  (I obtain the calibration filename by actually reading the ftpdetectinfo.txt file and then copying the filename from the Cal directory). 
		
		x Copy the ".\Cal\[calfile date/time] to "[date/time]\EmailFiles\Cal-[camera]" but don't change the filename.
		
		x Copy the ".\Cal\CameraSites.txt" file to "[date/time]\EmailFiles\Cal-[camera]" and rename it to "CameraSites-[camera].txt"
		
		x Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[camera]-[meteor count].txt" with the header stripped from it.
		
		x Copy the ".\ArchivedFiles\[date/time]\FTPdetectinfo.txt" file to "[date/time]\EmailFiles\FTPdetectinfo_scanned-[camera]-[meteor count].txt" with the header stripped from it.
		
		x I think that I will also add a file with a name to reflect the meteor count "archived=[count], confirmed=[count].txt" to make it easier to see
		
		- Copy the comments.txt file



:SETUP
	set bat_logfile=%bat_startdrive%\cams\submit.log
	set return=goto :EOF
	
	set bat_startlocation=%cd%
	set bat_startdrive=%cd:~0,2%
	set bat_caldir=%bat_startlocation%\Cal


:MAIN
	rem start the execution of the detection pass in background priority

	echo %date% %time%>"%bat_logfile%"
	set bat_>>"%bat_logfile%"
	call :GETDIRNAMES
	call :CREATEDIRS "!bat_dirname!"
	call :MOVEFILES "!bat_dirname!"
	call :READFILE
	call :COPYCALFILE "!bat_calfilename!" "!bat_camera!"

	call :STRIPHEADER bat_countconfirmed "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "confirmed"
	call :STRIPHEADER bat_countarchived  "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "scanned"

	call :COUNTFILE !bat_countarchived! !bat_countconfirmed!

	echo waiting 20 seconds...
	start /w wait 20
exit /b


:GETDIRNAMES
	echo :GETDIRNAMES %*
	rem Loop to iterate through all directory names under the ..\ConfirmedFiles structure.
	for /f "usebackq tokens=*" %%a in (`dir "%bat_startlocation%\ConfirmedFiles" /s/b /ad /on`) do (
		echo.
		echo %%a
		set bat_confirmeddirfull=%%a
		set bat_dirname=%%~nxa

		rem Note: The date/time in the CapturedFiles directory will be different
		rem       than the date/time in the ConfirmedFiles directory.  This is 
		rem       because the date/time of the CapturedFiles directory is 
		rem       the date/time when the directory was created, which is
		rem       several seconds before the end of the first 8 second video
		rem       section.  The date/time of the ConfirmedFiles and ArchivedFiles
		rem       directory is the date/time of the first file in the CapturedFiles
		rem       directory.
		set bat_yyyymmdd=!bat_dirname:~0,10!
		set bat_captureddir=%bat_startlocation%\CapturedFiles\!bat_yyyymmdd!

		set bat_submissiondir=%bat_startlocation%\SubmissionFiles\!bat_dirname!
		set bat_archiveddirfull=%bat_startlocation%\ArchivedFiles\!bat_dirname!
		set bat_emailfilesdir=!bat_submissiondir!\EmailFiles
		
		set bat_submitarchived=%bat_startlocation%\SubmissionFiles\!bat_dirname!\ArchivedFiles\!bat_dirname!
		set bat_submitconfirmed=%bat_startlocation%\SubmissionFiles\!bat_dirname!\Confirmed\!bat_dirname!
		set bat_submitcapturedbase=%bat_startlocation%\CapturedFiles\!bat_yyyymmdd!

		set bat_binfilesdir=!bat_submissiondir!\BinFiles
		set bat_avifilesdir=!bat_submissiondir!\AviFiles
	)&	rem end of for /f %%a in (`dir "%bat_startlocation%\ConfirmedFiles" /s/b /ad /on`)
	
%return%


:CREATEDIRS
	echo :CREATEDIRS %*
	rem usage: call :CREATEDIRS "!bat_dirname!"
		echo md "!bat_emailfilesdir!"
		     md "!bat_emailfilesdir!"
		echo md "!bat_binfilesdir!\Confirmed"
		     md "!bat_binfilesdir!\Confirmed"
		echo md "!bat_binfilesdir!\Archived"
		     md "!bat_binfilesdir!\Archived"
		echo md "!bat_binfilesdir!\Captured"
		     md "!bat_binfilesdir!\Captured"
		echo md "!bat_avifilesdir!"
		     md "!bat_avifilesdir!"	
		     
		     


	for /f "usebackq tokens=*" %%b in (`dir "!bat_captureddir!*.*" /s/b /ad /on`) do (
		echo move /y "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb"
		     move /y "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb"

		echo robocopy.exe "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb" /e /move
		rem  robocopy.exe "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb" /e /move
	)
%return%


:MOVEFILES
echo :MOVEFILES %*
    echo copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
         copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
             
    echo Packaged for submission on %date% %time%>"!bat_emailfilesdir!\submit.txt"
    echo Packaged for submission on %date% %time%>"!bat_captureddir!\submit.txt"

    echo move /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"
         move /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"


    echo move /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"
         move /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"

	echo copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"
	     copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"
rem	echo move /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"
rem	     move /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"

	echo copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"
	     copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"

	echo move /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
	     copy /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
rem	echo move /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
rem		 move /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
		  
	echo move /Y "!bat_confirmeddirfull!\comments.txt" "!bat_emailfilesdir!"
		 move /Y "!bat_confirmeddirfull!\comments.txt" "!bat_emailfilesdir!"

	echo move /Y "!bat_confirmeddirfull!\*.bin" "!bat_binfilesdir!\Confirmed"
		 move /Y "!bat_confirmeddirfull!\*.bin" "!bat_binfilesdir!\Confirmed"
	echo move /Y "!bat_archiveddirfull!\*.bin" "!bat_binfilesdir!\Archived"
		 move /Y "!bat_archiveddirfull!\*.bin" "!bat_binfilesdir!\Archived"

	for /f "usebackq tokens=*" %%b in (`dir "!bat_captureddir!*.*" /s/b /ad /on`) do (
		echo move /y "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb"
		     move /y "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb"

		echo robocopy.exe "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb" /e /move
		rem  robocopy.exe "%%~dpnxb" "!bat_binfilesdir!\Captured\%%~nxb" /e /move
	)


	ECHO RD /s /q "!bat_confirmeddirfull!"
		 RD /s /q "!bat_confirmeddirfull!"
	ECHO RD /s /q "!bat_archiveddirfull!"
		 RD /s /q "!bat_archiveddirfull!"
%return%


:READFILE
echo :READFILE %*
	rem Loop to read the FTPdetectinfo.txt file.

	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	
	for /f "usebackq tokens=*" %%a in (`type "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"`) do (
		set bat_temp=%%a
		set bat_temp=!bat_temp:~0,5!
		rem title bat_linecount=!bat_linecount! %%a
		set /a bat_linecount+=1
		if !bat_linecount! equ 1 (
			call :GETMETEORCOUNT bat_countconfirmed %%a
		) else (
			if !bat_linecount! equ 5 (
				call :GETFFDIR "%%a"
			) else (
				if !bat_linecount! equ 6 (
					rem call :GETCALDIR "%%a"
				) else (
					if !bat_linecount! equ 13 (
						call :GETCAMERA
						set bat_fffilename=%%a
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							call :GETCALNAME "%%a"
						) else (
							if "!bat_temp!" equ "FF!bat_camera!" (
								set bat_fffilename=%%a
								title working on FF file: "!bat_fffilename!"
								set /a bat_filecount+=1
							)
						)
					)
				)
			)
		)
	)
%return%



:GETMETEORCOUNT
echo :GETMETEORCOUNT %*
	rem Usage: call :GETMETEORCOUNT {return variable name} Meteor Count = 000533
	
	set bat_temp=%4
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	rem Strip leading zeros
	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	if not defined %1 set %1=0
%return%	




:STRIPHEADER
echo :STRIPHEADER %*
	rem Usage: call STRIPHEADER bat_variable sourcefile targetfile
	rem Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to 
	rem "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[bat_camera]-[meteor count].txt" 
	rem with the header stripped from it.
	
	set bat_sourcefile=%~5
	
	set /a bat_countscan=0

	if defined bat_emailfilesdir (
		!bat_echolog! ERROR [!bat_batchfile!:STRIPHEADER] Dangerous command:del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
		goto :STRIPHEADER_END
	)
	if defined bat_sourcefile (
		!bat_echolog! ERROR [!bat_batchfile!:STRIPHEADER] Dangerous command:del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
		goto :STRIPHEADER_END
	)
	if defined bat_camera (
		!bat_echolog! ERROR [!bat_batchfile!:STRIPHEADER] Dangerous command:del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
		goto :STRIPHEADER_END
	)
				
	echo for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`)
	for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`) do (
		set /a bat_countscan+=1
		if "!bat_countscan!" equ "1" (
			call :GETMETEORCOUNT  %1 %%~d
			if exist "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt" (
				del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
			)
		) else (
			if !bat_countscan! GTR 11 (
				TITLE :STRIPHEADER %* %%~d
				echo %%d>>"!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
			)
		)
	)
	
:STRIPHEADER_END
%return%


:GETFFDIR
echo :GETFFDIR %*
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
%return%


:GETCALDIR
echo :GETCALDIR %*
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
%return%


:GETCALNAME
echo :GETCALNAME %*
	rem 
	set bat_calfilename=%~1
%return%


:COPYCALFILE
echo :COPYCALFILE %*
	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!" (
		echo md "!bat_emailfilesdir!\Cal-!bat_camera!"
			 md "!bat_emailfilesdir!\Cal-!bat_camera!"
	)

	echo copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"
	copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"

	echo copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"
	copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"
%return%

:GETCAMERA
echo :GETCAMERA %*
	set bat_camera=!bat_temp:~2,3!
%return%





:COUNTFILE
echo :COUNTFILE %1 %2
	rem Create a file that has the meteorcounts

	echo Meteor Counts:  Archived="%1"   confirmed="%2">"!bat_emailfilesdir!\archived=%1, confirmed=%2.txt"

	echo copy /y /b "!bat_emailfilesdir!\archived=%1, confirmed=%2.txt" + "!bat_confirmeddirfull!\comments.txt" "!bat_emailfilesdir!\archived=%1, confirmed=%2.txt"
	copy /y /b "!bat_emailfilesdir!\archived=%1, confirmed=%2.txt"  + "!bat_emailfilesdir!\comments.txt" "!bat_emailfilesdir!\archived=%1, confirmed=%2.txt"

type "!bat_emailfilesdir!\archived=%1, confirmed=%2.txt"
%return%



:HELP
	@echo off
	echo.
	echo %0
	echo.
	echo Usage: %0 ^<datetimedir^>
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to create a collection of files that can be
	echo transmitted to Peter Jenniskens.  The transmissions need to be broken
	echo down into two different collections for the following purposes: 
	echo 	(1) Email the text files to him in a timely manner
	echo 	(2) Mail a DVD archive of the FF*.bin files along with the text files
	echo.
	echo The organization of these files needs to be as follows:
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\EmailFiles       contains:
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_confirmed.txt
	echo 							This is the one from the \cams\ConfirmedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_scanned.txt
	echo 							This is the one from the \cams\ArchivedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- CameraTimeOffsets.txt			renamed to CameraTimeOffsets_Brentwood_2011_08_01_05_00_19.txt
	echo 		- LASTSETTINGS.txt			renamed to LASTSETTINGS_Brentwood_2011_08_01_05_00_19.txt
	echo 		- ReprocessParameters.txt		renamed to ReprocessParameters_Brentwood_2011_08_01_05_00_19.txt
	echo 		- \cams\cal\CameraSites.txt		renamed to CameraSites_Brentwood_2011_08_01.txt
	echo 		- \cams\cal\CAL213_20110801_050019_514.txt
	echo.				 
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\BinFiles
	echo 		- contains the FF*.bin files
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\AviFiles
	echo.
	echo After the script verifies the movement of all these files, it is ready to create a
	echo zip file of everything in the ".\SubmissionFiles\<datetime>\EmailFiles" so that 
	echo they can be sent via email.
	echo.
	echo Most of this can be automated in this script in batch mode. We can't make a 
	echo DVD unattended though and that will need to be done manually.
	echo.
	echo To make the DVD, we copy ".\cams\SubmissionFiles\*.*" to the DVD burner.
	echo It might work better with RoboCopy, since I think it might support filling
	echo up a DVD and then continuing, but I'm not quite sure.
	echo.
	echo Once the DVD is burned, the files should be moved to ".\cams\SubmittedFiles\..." 
	echo.
	echo After a period of time, the specific ".\cams\SubmittedFiles\<datetime> directories can 
	echo be purged from the hard drive to make room for newer files. 
	echo.
	echo Ideally, all this should run from a copy on an external hard drive 
	echo so it can be processed on another computer and it won't interfere with capture, etc.
	echo.
	echo One issue to resolve is when there is an ArchivedFiles\^<date/time^> directory but no 
	echo matching ConfirmedFiles^<date/time^> directory.  This could have been caused by
	echo not being able to complete the processing due to some bug or corrupt files.  In that
	echo case, we just submit the files from the ArchivedFiles\^<date/time^> directory and 
	echo notate that in the readme.txt file in the directory.
	echo.
	echo Also, we need to start copying the necessary CAL and other files into the ArchivedFiles 
	echo directory as part of the ftp_reprocess.bat steps.  Perhaps we do that by calling
	echo a "complete_reprocessing.bat" routine.  Such a routine should be able to be run at
	echo anytime after FTP_Reprocess.exe is completed (or even while it is running).
	echo.
exit /b -99


:DONE
